﻿using System;using UnityEngine;using System.Collections;using System.Collections.Generic;using SimpleJSON;using System.Linq;using UnityEngine.UI;
namespace JayJayWon{
    public class ActRandomizerV2 : MVRScript{
        const string pluginName = "ActRandomizer";const string pluginAuthor = "JayJayWon"; const string pluginVersion = "v2.4";		
		public static Dictionary<string, string> MAPToTargetType = new Dictionary<string, string>() {{"Load Look","LOADLOOK"},{"Load Pose","LOADPOSE"},{"Load Preset","LOADPRESET"},{"Load Clothing Preset","LOADCLOTHPRESET"},{"Merge Clothing Preset","LOADCLOTHPRESET"},{"Remove Clothing Preset","LOADCLOTHPRESET"},{"Reset Sim Cloth Preset","LOADCLOTHPRESET"},{"Sim Dress Cloth Preset","LOADCLOTHPRESET"},{"Sim Undress Cloth Preset","LOADCLOTHPRESET"},{"Load App Preset","LOADAPPPRESET"},{"Load Hair Preset","LOADHAIRPRESET"},	{"Load General Preset","LOADGENPRESET"},{"Load Breast Preset","LOADBREASTPRESET"},{"Load Glute Preset","LOADGLUTEPRESET"},{"Load Skin Preset","LOADSKINPRESET"},{"Load Pose Preset","LOADPOSEPRESET"}, {"Load Morph Preset","LOADMORPHPRESET"}};
		public static Dictionary<string, FileTypeFolder> MAPTargetType = new Dictionary<string, FileTypeFolder>() {{"LOADLOOK",new FileTypeFolder{fileType="json",defaultFolder="Saves\\Person\\appearance"}},{"LOADPOSE",new FileTypeFolder{fileType="json",defaultFolder="Saves\\Person\\pose"}},{"LOADPRESET",new FileTypeFolder{fileType="json",defaultFolder="Saves\\Person\\full"}},{"LOADCLOTHPRESET",new FileTypeFolder{fileType="vap",defaultFolder="Custom\\Atom\\Person\\Clothing"}},{"LOADAPPPRESET",new FileTypeFolder{fileType="vap",defaultFolder="Custom\\Atom\\Person\\Appearance"}},{"LOADGENPRESET",new FileTypeFolder{fileType="vap",defaultFolder="Custom\\Atom\\Person\\General"}},{"LOADHAIRPRESET",new FileTypeFolder{fileType="vap",defaultFolder="Custom\\Atom\\Person\\Hair"}},{"LOADBREASTPRESET",new FileTypeFolder{fileType="vap",defaultFolder="Custom\\Atom\\Person\\BreastPhysics"}},{"LOADGLUTEPRESET",new FileTypeFolder{fileType="vap",defaultFolder="Custom\\Atom\\Person\\GlutePhysics"}},{"LOADSKINPRESET",new FileTypeFolder{fileType="vap",defaultFolder="Custom\\Atom\\Person\\Skin"}},{"LOADPOSEPRESET",new FileTypeFolder{fileType="vap",defaultFolder="Custom\\Atom\\Person\\Pose"}},{"LOADMORPHPRESET",new FileTypeFolder{fileType="vap",defaultFolder="Custom\\Atom\\Person\\Morphs"}}};
        public static Dictionary<string,string> MAPReceiversToGroups = new Dictionary<string, string>()   {{"Preset","Presets"},{"plugin#","Plugins" }, {"Trigger","Collision Triggers" },{"Animation","Node Animations" },{"animation","Node Animations" },{"Hair","Hair" }, {"hair","Hair" },{"Ponytail","Hair" }, {"Wrap","Clothing" },{"Sim","Clothing" }, {"Style","Clothing" },{"Material","Clothing" },{"Item","Clothing" },{"Clothing","Clothing" },{"BreastPhysicsMesh","Physics" },{"LowerPhysicsMesh","Physics" },{"control","Physics" },{"rescaleObject","Physics" },{"Physics","Physics" },{"Control","Node Controls" },{"Eye","Skin & Eyes" }, {"sclera","Skin & Eyes" },{"irises","Skin & Eyes" },{"skin","Skin & Eyes" },{"textures","Skin & Eyes" }, {"Skin","Skin & Eyes" }, {"lacrimal","Skin & Eyes" },{"mouth","Skin & Eyes" },{"teeth","Skin & Eyes" },{"tongue","Skin & Eyes" },{"Anatomy","Skin & Eyes" },{"HeadAudioSource","Speech" }, {"Speech","Speech" },{"Thought","Speech" },{"Auto","Speech" } };
		public static Dictionary<string,string> MAPReceiverGeometryParamsToGroup= new Dictionary <string,string>(){{"clothing:","Clothing"},{"toggle:","Clothing"},{"hair","Hair"},{"Colliders","Physics"}, {"disable","Skin & Eyes"},{"character","Skin & Eyes"}, {"use","Skin & Eyes" }};
		public static List<string> VAMSaveRestoreActions = new List<string>(){"SaveToStore1","SaveToStore2","SaveToStore3","RestoreAllFromStore1","RestoreAllFromStore2","RestoreAllFromStore3","RestorePhysicsFromStore1", "RestorePhysicsFromStore2","RestorePhysicsFromStore3", "RestoreAppearanceFromStore1","RestoreAppearanceFromStore2","RestoreAppearanceFromStore3","RestoreAllFromDefaults", "RestorePhysicalFromDefaults", "RestoreAppearanceFromDefaults"};
        public static string _vamFilePath = Application.dataPath.Substring(0,Application.dataPath.Length-8).Replace('/','\\');
        public override void Init() {
			try {
				_actCount = new JSONStorableFloat("actCount",0f,0f,1000f);_actCount.storeType = JSONStorableParam.StoreType.Full;RegisterFloat(_actCount);
				_hideVAMSaveRestoreActions = new JSONStorableBool("hideVAMSaveRestoreActions", true);			
				_disableTimeScale = new JSONStorableBool("disableTimeScale", true);	_disableTimeScale.storeType = JSONStorableParam.StoreType.Full;	RegisterBool(_disableTimeScale);
				_randomActionPlayButton = CreateButton("Start");_randomActionPlayButton.button.onClick.AddListener(() =>{ToggleRandomActPlay();});
				_startRandActs = new JSONStorableAction("StartRandomActs", () =>{StartRandActs();}); RegisterAction(_startRandActs);
				_finishRandActs = new JSONStorableAction("FinishRandomActs", () =>{FinishRandActs();});RegisterAction(_finishRandActs);
				_haltRandActs = new JSONStorableAction("HaltRandomActs", () =>{HaltRandActs();}); RegisterAction(_haltRandActs);
				_playSingleRandAct = new JSONStorableAction("PlaySingleRandAct", () =>{PlaySingleRandAct();});RegisterAction(_playSingleRandAct);
				_randomActionStopButton = CreateButton("Halt");_randomActionStopButton.button.onClick.AddListener(() =>{HaltRandActs();});
				_endCurrentAct = new JSONStorableAction("EndCurrentAct", () =>{EndCurrentAct();});RegisterAction(_endCurrentAct);
				_skipToNextAct = new JSONStorableAction("SkipToNextAct", () =>{SkipToNextAct();});RegisterAction(_skipToNextAct);
				_loopActs = new JSONStorableBool("LoopActs",true);_loopActs.storeType = JSONStorableParam.StoreType.Full;
				RegisterBool(_loopActs); var toggle = CreateToggle(_loopActs);toggle.label = "Loop Acts";_loopActs.toggle.onValueChanged.AddListener((bool input) => {ToggleLoop();});
				_enableAutoStart = new JSONStorableBool("Enable Auto Start on Scene Load",false);_enableAutoStart.storeType = JSONStorableParam.StoreType.Full;RegisterBool(_enableAutoStart);toggle = CreateToggle(_enableAutoStart);			
                _minActGapDuration = new JSONStorableFloat("Min Act Gap Duration (secs)", 0f,MinGapDurationUpdate, 0f, 100f,false);_minActGapDuration.storeType = JSONStorableParam.StoreType.Full;RegisterFloat (_minActGapDuration); CreateSlider(_minActGapDuration);				
                _maxActGapDuration = new JSONStorableFloat("Max Act Gap Duration (secs)", 0f,MaxGapDurationUpdate, 0f, 100f,false);_maxActGapDuration.storeType = JSONStorableParam.StoreType.Full;RegisterFloat (_maxActGapDuration);CreateSlider(_maxActGapDuration);				
                _minActsBetweenRepeat = new JSONStorableFloat("Min # Acts between repeats", 0f,MinActsBetweenUpdate, 0f, 10f,false);_minActsBetweenRepeat.storeType = JSONStorableParam.StoreType.Full;RegisterFloat (_minActsBetweenRepeat);CreateSlider(_minActsBetweenRepeat);				
				JSONStorableString randActStateJSON = new JSONStorableString("RandomiserState","");_randActStateText = CreateTextField(randActStateJSON,false);_randActStateText.height = 1;
                var btn = CreateButton("Add Act"); btn.button.onClick.AddListener(() =>{CreateNextAct();});
                btn = CreateButton("Copy Act"); btn.button.onClick.AddListener(() =>{CopyAct();});
                btn = CreateButton("Delete Act"); btn.button.onClick.AddListener(() =>{DeleteAct();});
                _togglePreAction = CreateButton("");_togglePreAction.buttonText.text = "Add Global Pre-Act Action"; _togglePreAction.button.onClick.AddListener(() => { TogglePreAction(); });
                _togglePostAction = CreateButton("");_togglePostAction.buttonText.text = "Add Global Post-Act Action";_togglePostAction.button.onClick.AddListener(() => { TogglePostAction(); });
				var spacer = CreateSpacer(false);spacer.height = 20;		
                _bulkOpJSON = new JSONStorableStringChooser("bulkOperation", null, null, "", SwitchBulkOp); _bulkOpJSON.storeType = JSONStorableParam.StoreType.Full; _displaybulkOpPopup = CreateSetupScrollablePopup(_bulkOpJSON, false, 400f, SyncBulkOps, "Bulk Operation");		
                _bulkOpTargetJSON = new JSONStorableStringChooser("bulkOperationTarget", null, null, "", SwitchBulkOpTarget);_bulkOpTargetJSON.storeType = JSONStorableParam.StoreType.Full;  _displaybulkOpTargetPopup = CreateSetupScrollablePopup(_bulkOpTargetJSON, false, 320f, SyncBulkOpTarget, "Bulk Operation Target");_bulkOpJSON.val = "Load Audio To";	
				btn = CreateButton("Execute Bulk Operation");btn.button.onClick.AddListener(() =>{ExecuteBulkOp();});
				spacer = CreateSpacer(false);spacer.height = 20;
                btn = CreateButton("Select Import Scene"); btn.button.onClick.AddListener(() => { SuperController.singleton.GetScenePathDialog(ImportFileSelected); }); _importPluginJSON = new JSONStorableStringChooser("importPlugin", GetImportPluginChoices(), "None", "ImportPlugin");var importPopup = CreateScrollablePopup(_importPluginJSON, false); importPopup.popupPanelHeight = 200f; importPopup.label = "Act Rndmizer Plugin"; btn = CreateButton("Import Acts from Scene"); btn.button.onClick.AddListener(() => { ImportActs(); });
                _currentActChooser = new JSONStorableStringChooser("actChooser", null, "Act 1", "Act", SwitchAct);_currentActChooser.storeType = JSONStorableParam.StoreType.Full;_displayActChooserPopup = CreateSetupScrollablePopup(_currentActChooser, true, 1000f, UpdateActChooserList, "Act");
				_uiRandomAct = new RandomAct (0, this);	spacer = CreateSpacer(false);spacer.height = 20;
				var timeScaleToggle = CreateToggle(_disableTimeScale, false); timeScaleToggle.label = "Disable Time Scale for Act Duration";
                spacer = CreateSpacer(false);spacer.height = 50;JSONStorableString pluginVersionJSON = new JSONStorableString("PluginVersion","");UIDynamicTextField dtext = CreateTextField(pluginVersionJSON,false);pluginVersionJSON.val = pluginName +" "+pluginVersion + "\nby "+pluginAuthor;dtext.height = 1;
				SuperController.singleton.onAtomUIDRenameHandlers += new SuperController.OnAtomUIDRename(this.AtomNameUpdate);LoadActs();				
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
        protected void TogglePreAction(){
            try{
                if (_preAct == null){ _preAct = new RandomAct(-1, this);_preAct.RegisterAct();_preAct.ResetDefaults(containingAtom.name);_togglePreAction.buttonText.text = "Remove Global Pre-Act Action";UpdateActChooserList();_currentActChooser.val = "Global Pre-Act Action";}
                else {_preAct.DeregisterAct(); _preAct = null;  _togglePreAction.buttonText.text = "Add Global Pre-Act Action";UpdateActChooserList();if (_currentActChooser.val == "Global Pre-Act Action"){_currentActChooser.val=_currentActChooser.choices[0];}}				
            } catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        protected void TogglePostAction(){
            try{
                if (_postAct == null){_postAct = new RandomAct(-2, this);_postAct.RegisterAct();_postAct.ResetDefaults(containingAtom.name);_togglePostAction.buttonText.text = "Remove Global Post-Act Action";UpdateActChooserList();_currentActChooser.val = "Global Post-Act Action";}
                else {_postAct.DeregisterAct(); _postAct = null;_togglePostAction.buttonText.text = "Add Post-Act Action";UpdateActChooserList();
					if (_currentActChooser.val == "Global Post-Act Action"){_currentActChooser.val=_currentActChooser.choices[0];}
				}				
            }
            catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        protected void ImportFileSelected(string fileName){
            try {
                if (fileName != "" && fileName.Substring(fileName.Length - 4, 4) == "json") {
                    List<string> pluginChoices = new List<string>();JSONNode sceneJSON = this.LoadJSON(fileName); JSONArray atomsJSON = sceneJSON["atoms"].AsArray;
                    for (int atomIndex = 0; atomIndex < atomsJSON.Count; atomIndex++){
                        JSONArray storablesJSON = atomsJSON[atomIndex]["storables"].AsArray;
                        for (int index = 0; index < storablesJSON.Count; index++) {
                            string storableID = (string)storablesJSON[index]["id"]; int pluginNameStartIndex = storableID.IndexOf("_");
                            if (storableID.Length > 6 && pluginNameStartIndex >= 0 && storableID.Substring(pluginNameStartIndex, storableID.Length - pluginNameStartIndex) == "_JayJayWon.ActRandomizerV2") { pluginChoices.Add(atomsJSON[atomIndex]["id"] + ">" + storableID); }
                        }
                    }
                    if (pluginChoices.Count == 0) { pluginChoices.Add("None"); _importFileName = ""; } else { _importFileName = fileName; }
                    _importPluginJSON.choices = pluginChoices; _importPluginJSON.val = pluginChoices[0];
                }
            }
            catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        protected void ImportActs() {
            try {
                if (_importFileName != "" && _importFileName.Substring(_importFileName.Length - 4, 4) == "json"){
                    JSONNode sceneJSON = this.LoadJSON(_importFileName);int atomNameEndIndex = _importPluginJSON.val.IndexOf(">");string atomName = _importPluginJSON.val.Substring(0, atomNameEndIndex);string pluginName = _importPluginJSON.val.Substring(atomNameEndIndex + 1); JSONArray atomsJSON = sceneJSON["atoms"].AsArray;
                    for (int atomIndex = 0; atomIndex < atomsJSON.Count; atomIndex++) {
                        if ((string)atomsJSON[atomIndex]["id"] == atomName) {
                            JSONArray storablesJSON = atomsJSON[atomIndex]["storables"].AsArray;
                            for (int index = 0; index < storablesJSON.Count; index++){
                                string storableID = (string)storablesJSON[index]["id"]; int pluginNameStartIndex = storableID.IndexOf("_");
                                if (storableID == pluginName) {
                                    int actCount = storablesJSON[index]["actCount"].AsInt; string newActName = _currentActChooser.val;
                                    for (int actNumber = 1; actNumber <= actCount; actNumber++) {newActName = CreateBlankAct();_randomActDict[newActName].RestoreFromJSON(actNumber, storablesJSON[index]);}
                                    _currentActChooser.val = newActName;UpdateActChooserList();
                                }
                            }
                        }
                    }
                }
            } catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        protected List<string> GetImportPluginChoices() { List<string> pluginChoices = new List<string>(); pluginChoices.Add("None"); return (pluginChoices); }
        public static void CloseAllPopup(UIDynamicPopup exception){
            if (_displaybulkOpPopup!=null && _displaybulkOpPopup != exception) { _displaybulkOpPopup.popup.visible = false; }
            if (_displaybulkOpTargetPopup != null && _displaybulkOpTargetPopup != exception) { _displaybulkOpTargetPopup.popup.visible = false; }
            if (_displayActChooserPopup != null && _displayActChooserPopup != exception) { _displayActChooserPopup.popup.visible = false; }
            if (_uiRandomAct != null){_uiRandomAct._startAction.CloseAllPopup(exception); _uiRandomAct._endAction.CloseAllPopup(exception); }
        }
        public List<string> GetAudioCategoryChoices(){
            List<string> audioCategoryChoices = new List<string>();
            if (URLAudioClipManager.singleton.GetCategories().Count > 0){foreach (string categoryName in URLAudioClipManager.singleton.GetCategories()){ audioCategoryChoices.Add(categoryName); } }
            foreach (string categoryName in EmbeddedAudioClipManager.singleton.GetCategories()) { audioCategoryChoices.Add(categoryName); }
            return audioCategoryChoices;
        }
        public List<string> GetAudioClipChoices(string category, bool pixieAudioOnly = false) {
            List<string> audioClipChoices = new List<string>();
			if (category == "web"){foreach (string clipName in URLAudioClipManager.singleton.GetCategoryClips("web").Select((clip) => clip.uid).ToList()){audioClipChoices.Add (clipName);}}
			else if (category != ""){
                foreach (string clipName in EmbeddedAudioClipManager.singleton.GetCategoryClips(category).Select((clip) => clip.uid).ToList()){if (!pixieAudioOnly || (category=="FemaleMoan" && clipName.Substring(0,8)=="FemPixie")) {audioClipChoices.Add(clipName); }}
			}
            return audioClipChoices;
		}
        protected void MinGapDurationUpdate(float minDuration){
			try{if (minDuration > _maxActGapDuration.val){_maxActGapDuration.val = minDuration ;}if (minDuration < 0f){minDuration = 0f;_minActGapDuration.val = 0f;}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
        protected void MaxGapDurationUpdate(float maxDuration){
			try {if (maxDuration < _minActGapDuration.val){_minActGapDuration.val = maxDuration ;}}
			catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void MinActsBetweenUpdate(float minActGap){try{
				if (minActGap < 0f){minActGap = 0f;_minActsBetweenRepeat.val = 0f;}
				else if (minActGap>_actCount.val -1f){minActGap = _actCount.val -1f;if (minActGap <0f){minActGap=0f;}_minActsBetweenRepeat.val = minActGap;}
				else{_minActsBetweenRepeat.val = Mathf.Round(minActGap);}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
        protected void SwitchAct(string actID){try {
                _uiRandomAct.DisableUpdates(true);
				if (actID == "Global Pre-Act Action"){_uiRandomAct.CopyActFrom(_preAct,false);}
				else if (actID == "Global Post-Act Action"){_uiRandomAct.CopyActFrom(_postAct,false);}
                else{_uiRandomAct.CopyActFrom(_randomActDict[actID],false);}
                _uiRandomAct.DisableUpdates(false);	RemovePopup(_displayActChooserPopup);_displayActChooserPopup = CreateSetupScrollablePopup(_currentActChooser, true, 1000f, null, "Act");_uiRandomAct.initRandomActUI();
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected string CreateNextAct(RandomAct copyAct=null){
            _actCount.val = _actCount.val + 1f; RandomAct newAct = AddAct((int)(_actCount.val));
            if (copyAct != null) { newAct.CopyActFrom(copyAct, false); }
            else{_uiRandomAct.DisableUpdates(true);_uiRandomAct.ResetDefaults(containingAtom.name); newAct.CopyActFrom(_uiRandomAct, false);_uiRandomAct.DisableUpdates(false); }
            string newActName = "Act " + _actCount.val.ToString();_currentActChooser.val = newActName;UpdateActChooserList();
            return newActName ;
		}
        protected string CreateBlankAct(){_actCount.val = _actCount.val + 1f; RandomAct newAct = AddAct((int)(_actCount.val));string newActName = "Act " + _actCount.val.ToString();   return newActName;}
        protected RandomAct AddAct(int actID){ RandomAct newAct = new RandomAct(actID, this); newAct.RegisterAct(); string newActName = "Act " + actID.ToString(); _randomActDict[newActName] = newAct; _randomActList.Add(newAct); return newAct;}
        JSONNode GetPluginJsonFromSave(string atomName, string storeName){
            foreach (JSONNode atoms in SuperController.singleton.GetSaveJSON()["atoms"].AsArray){if (atoms["id"].Value == atomName){
                    foreach (JSONNode storable in atoms["storables"].AsArray){if (storable["id"].Value == storeName){return storable;}}
                }
            }
            return null;
        }
        JSONNode GetPluginJsonFromLoad(string atomName, string storeName){
            foreach (JSONNode atoms in SuperController.singleton.loadJson ["atoms"].AsArray){
                if (atoms["id"].Value == atomName){foreach (JSONNode storable in atoms["storables"].AsArray) {if (storable["id"].Value == storeName) { return storable; } }}
            }
            return null;
        }
		protected int GetActCount(JSONNode varSaveJSON){
			int count=0;
			foreach (KeyValuePair<string, JSONNode> kvp in (JSONClass)varSaveJSON){
				if (kvp.Key.Length>9){if (kvp.Key.Substring(kvp.Key.Length-9,9)=="Atom1Name"){int varID = 0;if (kvp.Key.Substring(0,3)=="act"){Int32.TryParse(kvp.Key.Substring(3,kvp.Key.Length-3-9), out varID);count =Math.Max(varID,count);}}}
			}
			return (count);			
		}		
        protected void LoadActs (){
			int actCount =0;JSONNode savedJson = GetPluginJsonFromLoad(containingAtom.name, this.storeId);if (savedJson!=null){actCount=GetActCount(savedJson);
            for (int index = 1; index <= actCount; index++){ RandomAct newAct = AddAct(index); newAct.RestoreFromJSON(index, savedJson);}
			if (savedJson["act-1Atom1Type"]!=null){_preAct = new RandomAct(-1, this);_preAct.RegisterAct();_preAct.RestoreFromJSON(-1, savedJson);_togglePreAction.buttonText.text = "Remove Global Pre-Act Action";}
			if (savedJson["act-2Atom1Type"]!=null){_postAct = new RandomAct(-2, this);_postAct.RegisterAct();_postAct.RestoreFromJSON(-2, savedJson);_togglePostAction.buttonText.text = "Remove Global Post-Act Action";}
            UpdateActChooserList();}
        }
		protected float GetTotalActWeighting(){
			float totalActWeight = 0f;
			foreach (RandomAct randAct in _randomActList){if (randAct._actsSinceLastPlay >= _minActsBetweenRepeat.val){totalActWeight = totalActWeight + randAct._actProbability.val;}}
			return (totalActWeight);
		}
		protected string GetAct(float randomNumber){
			float increment = 0f;string actName = "NULL";
			foreach (RandomAct randAct in _randomActList){
				if (randAct._actsSinceLastPlay >= _minActsBetweenRepeat.val){
					increment = increment + randAct._actProbability.val;
					if (randomNumber <= increment && actName == "NULL" && randAct._actProbability.val >0f){actName = "Act "+((randAct._randomActID).ToString());}
				}
			}
			return (actName);
		}
		protected string RandomlySelectNextAct(){float totalActsProbWeight = GetTotalActWeighting ();float randomNumber = UnityEngine.Random.Range (0, totalActsProbWeight);string nextAct = GetAct(randomNumber);return nextAct;}
		protected void PlayAudio(){
			if (_audioAction == "PlayNow"){_audioSource.PlayNow(_nac);}if (_audioAction == "PlayIfClear"){_audioSource.PlayIfClear(_nac);}if (_audioAction == "PlayNowLoop"){_audioSource.PlayNowLoop(_nac);}if (_audioAction == "PlayNowClearQueue"){_audioSource.PlayNowClearQueue(_nac);}if (_audioAction == "PlayNext"){_audioSource.PlayNext(_nac);}if (_audioAction == "PlayNextClearQueue"){_audioSource.PlayNextClearQueue(_nac);}			
		}
		public void StartNextAct(string nextActName = ""){
			RandomAct nextAct ;		
			if (nextActName =="") {nextActName = RandomlySelectNextAct ();}
			_randomActDict.TryGetValue (nextActName,out nextAct);
			if (nextAct !=null){
				foreach (RandomAct act in _randomActList){act._actsSinceLastPlay = act._actsSinceLastPlay + 1;}
				nextAct._actsSinceLastPlay = 0;
				if (_preAct!=null){_preAct._startAction.PlayAction();}
				nextAct._startAction.PlayAction();	_disableTimeScaleNextAct = _disableTimeScale.val ;_startTime = GetTimeNow() ;
                if (SuperController.singleton.freezeAnimation) { _freezeStartTime = GetTimeNow(); } else { _freezeStartTime = 0; }
				_currentPlayingActName = nextActName ;	_currentActDuration = UnityEngine.Random.Range (nextAct._durationMin.val, nextAct._durationMax.val);
			}
			else{SuperController.LogMessage("StartNextAct: nextAct is null");}
		}
		protected void EndAct(){
			RandomAct currentAct ;_randomActDict.TryGetValue (_currentPlayingActName,out currentAct);
			if (currentAct!=null){
				if (_postAct!=null){_postAct._startAction.PlayAction();}
				currentAct._endAction.PlayAction();_disableTimeScaleNextAct = _disableTimeScale.val ;_startTime = GetTimeNow() ;
                if (SuperController.singleton.freezeAnimation) { _freezeStartTime = GetTimeNow(); } else { _freezeStartTime = 0; }
                _currentPlayingActName = "" ;_currentActDuration = UnityEngine.Random.Range (_minActGapDuration.val, _maxActGapDuration.val);
			}
		}
		public NamedAudioClip GetAudioClip(string audioCategory, string clipName){
            NamedAudioClip clip=null;
            if (audioCategory == "web") { clip = URLAudioClipManager.singleton.GetClip(clipName); }
            else { clip = EmbeddedAudioClipManager.singleton.GetClip(clipName); }
			return clip;
		}
		protected void ToggleLoop(){if (_loopActs.val) {_stopAfterNextAct = false;}else{_stopAfterNextAct = true;}	}
		protected void ToggleRandomActPlay(){try{if (!_isRandomActPlayStarted){StartRandActs();}else {_currentActDuration = 0f;}}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}
		protected void StartRandActs(){try{if (!_isRandomActPlayStarted){_isRandomActPlayStarted = true;_isWaitingBetweenActs = false ;if (_loopActs.val){_stopAfterNextAct = false;}else {_stopAfterNextAct = true;}StartNextAct ("");}}catch (Exception e) {SuperController.LogError("Exception caught: " + e);_isRandomActPlayStarted = false;}}
		protected void FinishRandActs(){if (_isRandomActPlayStarted && !_stopAfterNextAct){_stopAfterNextAct = true;}}
		protected void HaltRandActs(){if (_isRandomActPlayStarted){_currentActDuration = 0f;_stopAfterNextAct = true;if (_isWaitingBetweenActs){_isRandomActPlayStarted = false;_isWaitingBetweenActs = false;}}}
		protected void PlaySingleRandAct(){ try{StartRandActs();FinishRandActs();}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}
		protected void EndCurrentAct(){if (_isRandomActPlayStarted && !_isWaitingBetweenActs){_currentActDuration = 0f;}}
		protected void SkipToNextAct(){try{if (_isRandomActPlayStarted && !_isWaitingBetweenActs){EndAct();StartNextAct("");}else if (_isRandomActPlayStarted && _isWaitingBetweenActs){_currentActDuration = 0f;}}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}}
		protected void CopyAct(){try{string newActName = CreateNextAct(_uiRandomAct);}catch (Exception e) { SuperController.LogError("Exception caught: " + e); }}
		protected void DeleteAct(){
			try{
				int deletedActNumber = _randomActDict[_currentActChooser.val]._randomActID ;
				foreach (RandomAct randAct in _randomActList){
					if (randAct._randomActID > deletedActNumber){_randomActDict["Act "+(randAct._randomActID -1).ToString()].CopyActFrom(randAct,false);}
					if (randAct._randomActID == _actCount.val ){randAct.DeregisterAct();}
				}				
				_randomActDict.Remove("Act "+_actCount.val.ToString());_randomActList.RemoveAt((int)(_actCount.val-1f));_actCount.val = _actCount.val - 1f;
				if(_actCount.val ==0f){CreateNextAct();}
				UpdateActChooserList();
				if (deletedActNumber>((int)_actCount.val)){deletedActNumber =(int) _actCount.val;}
                if (_currentActChooser.val != "Act " + deletedActNumber.ToString()) { _currentActChooser.val = "Act " + deletedActNumber.ToString(); }
                else { SwitchAct("Act " + deletedActNumber); }
            }catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void LoadVisemes (){
			try{
				List<string> allChoices = new List<string>();JSONStorable bulkReceiver = null; Atom atom = SuperController.singleton.GetAtomByUid(_bulkOpTargetJSON.val);
                foreach (string receiverName in atom.GetStorableIDs()){if (receiverName.Contains("VisemeAligner")) { bulkReceiver = atom.GetStorableByID(receiverName); }}
                allChoices = bulkReceiver.GetActionNames();string newActName = _currentActChooser.val;
                foreach (string visemeName in allChoices){
					if (visemeName.StartsWith ("Speak")){
						newActName = CreateBlankAct();RandomAct newAct ;RandomAct currentAct ;_randomActDict.TryGetValue(newActName, out newAct) ;_randomActDict.TryGetValue(_currentActChooser.val, out currentAct) ;string clipName = visemeName.Substring(6) ;NamedAudioClip nac = URLAudioClipManager.singleton.GetClip(clipName);AudioClip audioClip =  nac.clipToPlay;float audioClipLength = audioClip.length ; newAct._startAction._atomName.val = _bulkOpTargetJSON.val; newAct._startAction._atomType.val = atom.type;            
                        if (atom.type == "Person") { newAct._startAction._receiverGroupName.val = "Plugins"; }
                        newAct._startAction._receiverName.val = bulkReceiver.storeId;newAct._startAction._targetName.val = visemeName;newAct._startAction._targetType.val = "ACTION"; newAct._actProbability.val = 1f ;newAct._durationMin.val = 0f ;newAct._durationMax.val = audioClipLength ;newAct._durationMin.val = audioClipLength ;newAct._endAction._atomName.val = _bulkOpTargetJSON.val;newAct._endAction._atomType.val = atom.type;
                        if (atom.type == "Person") { newAct._endAction._receiverGroupName.val = "Plugins"; }
                        newAct._endAction._receiverName.val = bulkReceiver.storeId;newAct._endAction._targetName.val = "StopSpeaking";newAct._endAction._targetType.val = "ACTION";
                    }
				}
                _currentActChooser.val = newActName;UpdateActChooserList();
            }
            catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void LoadAudio (bool pixieAudioOnly = false){
			try{
				List<string> audioClips = new List<string>();string audioCategory = "";
                if (pixieAudioOnly) {audioCategory ="FemaleMoan"; }else { audioCategory ="web"; }
				audioClips = GetAudioClipChoices(audioCategory,pixieAudioOnly); Atom atom = SuperController.singleton.GetAtomByUid(_bulkOpTargetJSON.val);string bulkReceiverName ="";string newActName = _currentActChooser.val;
                if (atom.type == "Person") {bulkReceiverName="HeadAudioSource";}
				if (atom.type == "RhythmAudioSource") {bulkReceiverName="RhythmSource";}
				if (atom.type == "AudioSource") {bulkReceiverName="AudioSource";}
				if (atom.type == "AptSpeaker") {bulkReceiverName="AptSpeaker_Import";}
				if (audioClips.Count >0 ){
					foreach (string audioClipName in audioClips){
						NamedAudioClip nac = GetAudioClip(audioCategory,audioClipName);AudioClip audioClip =  nac.clipToPlay;
                        if (audioClip != null){
                            newActName = CreateBlankAct();RandomAct newAct = _randomActDict[newActName];
                            float audioClipLength = audioClip.length;
                            newAct._startAction._atomName.val = _bulkOpTargetJSON.val;newAct._startAction._atomType.val = atom.type;
                            if (atom.type == "Person") { newAct._startAction._receiverGroupName.val = "Speech"; }
                            newAct._startAction._receiverName.val = bulkReceiverName;newAct._startAction._targetName.val = "PlayNow";newAct._startAction._targetType.val = "AUDIO";newAct._startAction._targetAudioCategory.val = audioCategory; newAct._startAction._targetStringChooserValue.val = audioClipName;newAct._actProbability.val = 1.0f;
                            newAct._durationMin.val = 0;newAct._durationMax.val = audioClipLength;newAct._durationMin.val = audioClipLength;
                            newAct._endAction._atomName.val = _bulkOpTargetJSON.val; newAct._endAction._atomType.val = atom.type;
                            if (atom.type == "Person") { newAct._endAction._receiverGroupName.val = "Speech"; }
                            newAct._endAction._receiverName.val = bulkReceiverName;newAct._endAction._targetName.val = "Stop";  newAct._endAction._targetType.val = "ACTION";
                        }
					}
                    _currentActChooser.val =  newActName;UpdateActChooserList();
                }
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
        protected void LoadImages(string folder){
            try {
                Atom atom = SuperController.singleton.GetAtomByUid(_bulkOpTargetJSON.val); string filePath; string relFilePath;
                if (String.IsNullOrEmpty(folder)) { return; }
                else { 
                    string[] files = SuperController.singleton.GetFilesAtPath(folder); string newActName = _currentActChooser.val;
                    foreach (string file in files){
                        filePath = file.Substring(0,_vamFilePath.Length);
                        if (filePath != _vamFilePath){ SuperController.LogMessage("File must be within VAM directory structure: " + ActRandomizerV2._vamFilePath); return;}
                        relFilePath = file.Substring(_vamFilePath.Length); newActName = CreateBlankAct(); RandomAct newAct = _randomActDict[newActName];newAct._startAction._atomName.val = _bulkOpTargetJSON.val; newAct._startAction._atomType.val = atom.type;newAct._startAction._receiverName.val = "Image";newAct._startAction._targetName.val = "url";newAct._startAction._targetType.val = "URL";newAct._startAction._targetFileURLValue.val = relFilePath;newAct._actProbability.val = 1.0f; newAct._durationMin.val = 0; newAct._durationMax.val = 5f;newAct._durationMin.val = 5f;newAct._endAction._atomName.val = _bulkOpTargetJSON.val;newAct._endAction._atomType.val = atom.type;newAct._endAction._receiverName.val = "Image";newAct._endAction._targetName.val = "NO ACTION";newAct._endAction._targetType.val = "OTHER";
                    }
                    _currentActChooser.val = newActName;UpdateActChooserList();
                }
            } catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        protected void BulkCopyActs(){
			try{
				string[] targetName = _bulkOpTargetJSON.val.Split('>');JSONNode savedJson = GetPluginJsonFromSave(targetName[0], targetName[1]);int actCount = savedJson["actCount"].AsInt;string newActName = _currentActChooser.val;
				for (int actNumber=1; actNumber <= actCount; actNumber++){newActName = CreateBlankAct();_randomActDict[newActName].RestoreFromJSON(actNumber,savedJson);}
                _currentActChooser.val = newActName; UpdateActChooserList();
            }catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void ChangeAtomName(){
			try{
				Atom atomOld = SuperController.singleton.GetAtomByUid (_bulkOpJSON.val.Substring(7,_bulkOpJSON.val.Length-7));Atom atomNew = SuperController.singleton.GetAtomByUid (_bulkOpTargetJSON.val);List <string> newAtomReceivers = atomNew.GetStorableIDs ();
				foreach (RandomAct act in _randomActList){	
					if (act._startAction._atomName.val == _bulkOpJSON.val.Substring(7,_bulkOpJSON.val.Length-7)){
						if (newAtomReceivers.Contains(act._startAction._receiverName.val) || act._startAction._receiverName.val== "Load Look/Pose/Preset" || act._startAction._receiverName.val == "Dress/Undress Clothing") {act._startAction._atomName.val = _bulkOpTargetJSON.val ;}
						else {SuperController.LogMessage("Act "+act._randomActID.ToString()+" start Receiver is not available in the target Atom, so Atom change was skipped");}
					}
					if (act._endAction._atomName.val == _bulkOpJSON.val.Substring(7,_bulkOpJSON.val.Length-7)){
						if (newAtomReceivers.Contains(act._endAction._receiverName.val) || act._endAction._receiverName.val == "Load Look/Pose/Preset" || act._endAction._receiverName.val == "Dress/Undress Clothing") {act._endAction._atomName.val = _bulkOpTargetJSON.val ;}
						else {SuperController.LogMessage("Act "+act._randomActID.ToString()+" end Receiver is not available in the target Atom, so Atom change was skipped");}
					}
				}
				SwitchAct(_currentActChooser.val);_bulkOpJSON.val = "Change " + _bulkOpTargetJSON.val;
            } catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void UpdateActChooserList(){
			List <string> actChoices = new List <string>() ; ActRandomizerV2.CloseAllPopup(_displayActChooserPopup);
            if (_preAct != null) { actChoices.Add("Global Pre-Act Action"); }
            if (_postAct != null) { actChoices.Add("Global Post-Act Action"); }
            foreach (RandomAct act in _randomActList){actChoices.Add("Act "+act._randomActID.ToString());}
			_currentActChooser.choices = actChoices;
		}
		protected void SyncBulkOps(){
			try{
                ActRandomizerV2.CloseAllPopup(_displaybulkOpPopup);List <string> bulkOpChoices = new List <string>() ;	bulkOpChoices.Add ("Load Audio To"); bulkOpChoices.Add("Load Pixie Audio To"); bulkOpChoices.Add ("Load Visemes From"); bulkOpChoices.Add ("Copy Acts From"); bulkOpChoices.Add("Load Images To");
                foreach (RandomAct randAct in _randomActList){
					if (!bulkOpChoices.Contains("Change "+randAct._startAction._atomName.val)) {bulkOpChoices.Add("Change "+randAct._startAction._atomName.val);}
					if (!bulkOpChoices.Contains("Change "+randAct._endAction._atomName.val)) {bulkOpChoices.Add("Change "+randAct._endAction._atomName.val);}
				}
				_bulkOpJSON.choices = bulkOpChoices;if (!_bulkOpJSON.choices.Contains(_bulkOpJSON.val)){_bulkOpJSON.val=_bulkOpJSON.choices[0];}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void SyncBulkOpTarget(){
			try{
                ActRandomizerV2.CloseAllPopup(_displaybulkOpTargetPopup);List <string> bulkOpTargetChoices = new List <string>() ;	
				foreach (Atom atom in SuperController.singleton.GetAtoms()){
					if (_bulkOpJSON.val.Substring(0,6) == "Change"){
                        string bulkAtomType = "";
                        foreach (RandomAct act in _randomActList) { 
                            if (_bulkOpJSON.val.Substring(7, _bulkOpJSON.val.Length - 7)==act._startAction._atomName.val) { bulkAtomType = act._startAction._atomType.val;break; }
                            if (_bulkOpJSON.val.Substring(7, _bulkOpJSON.val.Length - 7) == act._endAction._atomName.val) { bulkAtomType = act._endAction._atomType.val; break; }
                        }
						if (!bulkOpTargetChoices.Contains(atom.uid) && _bulkOpJSON.val.Substring(7,_bulkOpJSON.val.Length-7)!=atom.uid && atom.type== bulkAtomType) {bulkOpTargetChoices.Add(atom.uid);}
					}
                    else if (_bulkOpJSON.val == "Load Images To") {
                        if (atom.type == "ImagePanel" || atom.type == "ImagePanelEmissive"){if (!bulkOpTargetChoices.Contains(atom.uid)) { bulkOpTargetChoices.Add(atom.uid); }}
                    }
                    else {
						foreach (string receiverName in atom.GetStorableIDs()){
							if (_bulkOpJSON.val == "Load Audio To" || _bulkOpJSON.val == "Load Pixie Audio To"){
								if (receiverName=="AudioSource" || receiverName=="RhythmSource" || receiverName=="HeadAudioSource" || receiverName=="AptSpeaker_Import"){if (!bulkOpTargetChoices.Contains(atom.uid)) {bulkOpTargetChoices.Add(atom.uid);}}
							}
                            else if (_bulkOpJSON.val == "Load Images To"){
                                if (receiverName.Length >= 15){
                                    if (receiverName.Substring(receiverName.Length - 15, 15) == "ActRandomizerV2"){
                                        if (!bulkOpTargetChoices.Contains(atom.uid)) { bulkOpTargetChoices.Add(atom.uid + ">" + receiverName); }
									}
                                }
                            }							
							else if (_bulkOpJSON.val == "Load Visemes From"){
								if (receiverName.Length >= 13){
									if (receiverName.Contains("VisemeAligner")){
										if (!bulkOpTargetChoices.Contains(atom.uid)) {bulkOpTargetChoices.Add(atom.uid);}
									}
								}
							}
							else if (_bulkOpJSON.val == "Copy Acts From"){
								if (receiverName.Length >= 15){
									if (receiverName.Substring(receiverName.Length -15,15)=="ActRandomizerV2"){
										if (!bulkOpTargetChoices.Contains(atom.uid)) {bulkOpTargetChoices.Add(atom.uid+">"+receiverName);}
									}							
								}
							}
                        }
					}
				}
				if (bulkOpTargetChoices.Count == 0) {bulkOpTargetChoices.Add("No Target");}
				_bulkOpTargetJSON.choices= bulkOpTargetChoices;
				if (!_bulkOpTargetJSON.choices.Contains(_bulkOpTargetJSON.val)){_bulkOpTargetJSON.val=_bulkOpTargetJSON.choices[0];}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void SwitchBulkOp(string bulkOp){SyncBulkOpTarget();}protected void SwitchBulkOpTarget(string bulkOpTarget){}		
		protected void ExecuteBulkOp(){
			try{
				if (_bulkOpJSON.val == "Load Visemes From"){LoadVisemes();}
				else if (_bulkOpJSON.val == "Load Audio To"){LoadAudio();}
                else if (_bulkOpJSON.val == "Load Pixie Audio To") { LoadAudio(true); }
                else if (_bulkOpJSON.val == "Copy Acts From"){BulkCopyActs();}
				else if (_bulkOpJSON.val.Substring(0,6) == "Change"){ChangeAtomName();}
                else if (_bulkOpJSON.val == "Load Images To") { SuperController.singleton.GetDirectoryPathDialog(LoadImages); }
            }catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected void AtomNameUpdate(string oldName, string newName){
			try{
				foreach (RandomAct randAct in _randomActList){
					if (oldName == randAct._startAction._atomName.val){randAct._startAction._atomName.val = newName ;}
					if (oldName == randAct._endAction._atomName.val){randAct._endAction._atomName.val = newName ;}
				}
				if (_uiRandomAct._startAction._atomName.val == oldName){ _uiRandomAct._startAction._atomName.val = newName;}
				if (_uiRandomAct._endAction._atomName.val == oldName){ _uiRandomAct._endAction._atomName.val = newName;}
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		void Start() {
			try	{
				if (_enableAutoStart.val) {_autoStart=true;} else {_autoStart=false;}
				if (_actCount.val == 0f){CreateNextAct();}
				_currentActChooser.val = "Act 1"; SwitchAct("Act 1");_disableTimeScaleNextAct = _disableTimeScale.val ;
			}catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}
		protected long GetTimeNow (){long msTime ; if (_disableTimeScaleNextAct) { msTime = (long)(Time.unscaledTime * 1000); } else { msTime = (long) (Time.time *1000); }return (msTime);}
		public UIDynamicPopup CreateSetupScrollablePopup(JSONStorableStringChooser stringChooserJSON, bool rightUI, float panelHeight, UIPopup.OnOpenPopup callbackMethod,string label){
			UIDynamicPopup dynamicPopup = CreateScrollablePopup(stringChooserJSON, rightUI);dynamicPopup.popupPanelHeight = panelHeight;
			dynamicPopup.popup.onOpenPopupHandlers += callbackMethod ;dynamicPopup.label = label;
			return(dynamicPopup);
		}
        public void SaveUIAct(){
			if (_currentActChooser.val.Substring(0,3) == "Act"){_randomActDict[_currentActChooser.val].CopyActFrom(_uiRandomAct,false);}
			else if (_currentActChooser.val == "Global Pre-Act Action"){_preAct.CopyActFrom(_uiRandomAct,false);}
			else if (_currentActChooser.val == "Global Post-Act Action"){_postAct.CopyActFrom(_uiRandomAct,false);}
        }
		void Update() {
			try {
				if (!SuperController.singleton.isLoading){
					if (_autoStart && !_isRandomActPlayStarted){_autoStart = false; StartRandActs();}
					if (!_isRandomActPlayStarted){_randomActionPlayButton.buttonText.text = "Start";}
					else if (_isWaitingBetweenActs) {_randomActionPlayButton.buttonText.text = "End Gap";}
					else {_randomActionPlayButton.buttonText.text = "End "+_currentPlayingActName;}
					string txt = "RANDOMIZER STATUS\n";long currentTime = GetTimeNow() ;long startDisplayTime ;
                    if (_freezeStartTime == 0) { startDisplayTime = _startTime; } else { startDisplayTime = _startTime + (currentTime - _freezeStartTime); }
                    if (_isRandomActPlayStarted && !_isWaitingBetweenActs) { txt = txt + "Playing " + _currentPlayingActName + ". Time remaining: " + (_currentActDuration - (((float)(currentTime - startDisplayTime)) / 1000f)).ToString("F1"); }
                    else if (_isRandomActPlayStarted && _isWaitingBetweenActs) { txt = txt + "Waiting. Time to next Act is: " + (_currentActDuration - (((float)(currentTime - startDisplayTime)) / 1000f)).ToString("F1"); }
                    else { txt = txt + "No Acts Playing"; }
                    if (_stopAfterNextAct && _isRandomActPlayStarted) { txt = txt + "\nFinishing after this Act"; }
                    _randActStateText.text = txt;
                    if (_audioLoading){
						if (_freezeStartTime ==0){_freezeStartTime=currentTime;}
						AudioClip ac = _nac.clipToPlay ;
						if (ac!= null) {if (_nac.clipToPlay.loadState != AudioDataLoadState.Loading ){_audioLoading = false;PlayAudio();}}
					}
					else if (SuperController.singleton.freezeAnimation == false){					
						if (_freezeStartTime>0){_startTime = _startTime + (currentTime-_freezeStartTime);}
						_freezeStartTime=0;
						if (_isRandomActPlayStarted && !_isWaitingBetweenActs){
							if ((currentTime -_startTime) > _currentActDuration*1000){
								EndAct();
								if (_stopAfterNextAct){_isRandomActPlayStarted = false; _isWaitingBetweenActs = false ; _stopAfterNextAct = false;}
								else{_isWaitingBetweenActs = true;}
							}
						}
						if (_isRandomActPlayStarted && _isWaitingBetweenActs){if ((currentTime -_startTime) > _currentActDuration*1000){_isWaitingBetweenActs = false ;StartNextAct();}}
					}else{if (_freezeStartTime ==0){_freezeStartTime=currentTime;}}
                }
			}catch (Exception e) {SuperController.LogError("Exception caught in "+containingAtom.name+" "+this.storeId+": " + e);}
		}
		protected JSONStorableAction _startRandActs; protected JSONStorableAction _finishRandActs; protected JSONStorableAction _haltRandActs;	protected JSONStorableAction _skipToNextAct; protected JSONStorableAction _endCurrentAct; protected JSONStorableAction _playSingleRandAct ;protected JSONStorableFloat _minActGapDuration ; protected JSONStorableFloat _maxActGapDuration ; protected JSONStorableFloat _minActsBetweenRepeat ;public JSONStorableStringChooser _currentActChooser;private JSONStorableFloat _actCount ;protected JSONStorableStringChooser _bulkOpJSON; protected JSONStorableStringChooser _bulkOpTargetJSON; protected JSONStorableStringChooser _importPluginJSON;   public JSONStorableBool _hideVAMSaveRestoreActions ; protected JSONStorableBool _loopActs ; protected JSONStorableBool _enableAutoStart ; protected JSONStorableBool _disableTimeScale ;
		public static RandomAct _uiRandomAct ;
        private UIDynamicButton _randomActionPlayButton ;private UIDynamicButton _randomActionStopButton ; private UIDynamicButton _togglePreAction; private UIDynamicButton _togglePostAction;protected UIDynamicTextField _randActStateText ;	protected static UIDynamicPopup _displaybulkOpPopup;protected static UIDynamicPopup _displaybulkOpTargetPopup;protected static UIDynamicPopup _displayActChooserPopup;	
		public static bool _actSwitching = false; public bool _isRandomActPlayStarted = false; public bool _stopAfterNextAct = false ; public bool _isWaitingBetweenActs = false ;private bool _autoStart =false; private bool _audioLoading = false; bool _disableTimeScaleNextAct = true;
		protected long _startTime =0; protected float _currentActDuration = 0f ; protected long _freezeStartTime =0 ;protected string _currentPlayingActName ; protected string _audioAction ; protected string _importFileName = ""; protected AudioSourceControl _audioSource ;protected NamedAudioClip _nac ;	
        List<RandomAct> _randomActList = new List<RandomAct>();List<string> _actChoices = new List<string>();
        RandomAct _preAct = null;RandomAct _postAct = null;
        protected Dictionary<string, RandomAct> _randomActDict = new Dictionary<string, RandomAct>();
	}	
	public class RandomAct{
        public RandomAct(int actID, ActRandomizerV2 parent ){
			_randomActID = actID;_startAction = new RandomAction (actID,"1",this);_endAction = new RandomAction (actID,"2",this);
            float defaultProbability;
            if (actID == 0) { defaultProbability = 1f; } else { defaultProbability = -1f; }
			_actProbability = new JSONStorableFloat("act"+actID.ToString()+"Probability" , defaultProbability, 0f, 100f,false); _actProbability.storeType = JSONStorableParam.StoreType.Full;
            float defaultDuration = 0f;
            if (actID == 0) { defaultDuration = 5f; } else { defaultDuration = -1f; }
            _durationMin = new JSONStorableFloat("act"+actID.ToString()+"DurationMin" , defaultDuration, 0f, 1000f,false);_durationMin.storeType = JSONStorableParam.StoreType.Full;
            _durationMax = new JSONStorableFloat("act" + actID.ToString() + "DurationMax", defaultDuration, 0f, 1000f,false); _durationMax.storeType = JSONStorableParam.StoreType.Full;
            _parent = parent;_actsSinceLastPlay = 100000000;
            if (actID > 0) { _disableUIUpdates = true;_startAction._disableUIUpdates = true;_endAction._disableUIUpdates = true; }
		}
        public void ResetDefaults(string atomName){_actProbability.val = 1f;_durationMin.val = 5f; _durationMax.val = 5f;_actsSinceLastPlay = 100000000; _startAction.ResetDefaults(atomName);_endAction.ResetDefaults(atomName); }
        public void RegisterAct(){ _startAction.RegisterRandomAction();_endAction.RegisterRandomAction();_parent.RegisterFloat(_actProbability);_parent.RegisterFloat(_durationMin);_parent.RegisterFloat(_durationMax);}
		public void DeregisterAct(){ _startAction.DeregisterRandomAction();_endAction.DeregisterRandomAction();_parent.DeregisterFloat(_actProbability);_parent.DeregisterFloat(_durationMin);_parent.DeregisterFloat(_durationMax);}
		public void CopyActFrom(RandomAct randomAct, bool updateID =true){if (updateID){_randomActID=randomAct._randomActID;}_actProbability.val = randomAct._actProbability.val;_durationMin.val = randomAct._durationMin.val;_durationMax.val = randomAct._durationMax.val;_startAction.CopyActionFrom(randomAct._startAction);_endAction.CopyActionFrom(randomAct._endAction);}
		public void RestoreFromJSON(int index, JSONNode actSaveJSON){_actProbability.val = actSaveJSON["act"+ index.ToString()+ "Probability"].AsFloat ;_durationMin.val = actSaveJSON["act"+ index.ToString()+ "DurationMin"].AsFloat ;_durationMax.val = actSaveJSON["act" + index.ToString() + "DurationMax"].AsFloat;_startAction.RestoreFromJSON(index,"1",actSaveJSON);_endAction.RestoreFromJSON(index,"2",actSaveJSON);}
		protected void TestAct(){
            try { 
                if (!_parent._isRandomActPlayStarted){_parent._isRandomActPlayStarted = true; _parent._isWaitingBetweenActs = false; _parent._stopAfterNextAct = true;_parent.StartNextAct(_parent._currentActChooser.val);}
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        protected void SyncProb(float probability){
            try{ if (probability < 0f){_actProbability.val = 0f;}if (!_disableUIUpdates) { _parent.SaveUIAct(); }
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        protected void SyncMinDuration(float minDuration){
            try{
                if (minDuration > _durationMax.val){ _durationMax.val = minDuration ;}
                if (minDuration < 0f){_durationMin.val = 0f; _durationMin.val = 0f;}
                if (!_disableUIUpdates) { _parent.SaveUIAct(); }
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        protected void SyncMaxDuration(float maxDuration){
            try{
                if (maxDuration < _durationMin.val){ _durationMin.val = maxDuration ;}
                if (!_disableUIUpdates) { _parent.SaveUIAct(); }  
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void DisableUpdates(bool disableState){_disableUIUpdates = disableState; _startAction._disableUIUpdates = disableState; _endAction._disableUIUpdates = disableState;}
        public void initRandomActUI(){
            ActRandomizerV2 parentMVR = _parent;
            if (_displayProbabilityFloatSlider != null) { parentMVR.RemoveSlider(_displayProbabilityFloatSlider); }
            if (_displayDurationMinFloatSlider != null) { parentMVR.RemoveSlider(_displayDurationMinFloatSlider); }
            if (_displayDurationMaxFloatSlider != null) { parentMVR.RemoveSlider(_displayDurationMaxFloatSlider); }
			if (_displayActTextField !=null){parentMVR.RemoveTextField(_displayActTextField);}
            if (_displayTestButton != null) { parentMVR.RemoveButton(_displayTestButton); }
            if (_displayHVSRAToggle != null) { parentMVR.RemoveToggle(_displayHVSRAToggle); }
            if (_displaySpacer != null) { parentMVR.RemoveSpacer(_displaySpacer); }
			if(_parent._currentActChooser.val.Substring(0,3)=="Act"){_displayProbabilityFloatSlider = parentMVR.CreateSlider(_actProbability, true);_displayProbabilityFloatSlider.slider.onValueChanged.AddListener((float val) => { this.SyncProb(val); });_displayProbabilityFloatSlider.label = "Act Probability Weighting";}
            _startAction.initRandomActionUI();
			if(_parent._currentActChooser.val.Substring(0,3)=="Act"){_displayDurationMinFloatSlider = parentMVR.CreateSlider(_durationMin, true);_displayDurationMinFloatSlider.slider.onValueChanged.AddListener((float val) => { this.SyncMinDuration(val); });_displayDurationMinFloatSlider.label = "Act Minimum Duration";_displayDurationMaxFloatSlider = parentMVR.CreateSlider(_durationMax, true);_displayDurationMaxFloatSlider.slider.onValueChanged.AddListener((float val) => { this.SyncMaxDuration(val); });_displayDurationMaxFloatSlider.label = "Act Maximum Duration";}
            _endAction.initRandomActionUI();
			if(_parent._currentActChooser.val.Substring(0,3)=="Act"){_displayTestButton = parentMVR.CreateButton("Test Act", true); _displayTestButton.button.onClick.AddListener(() => { TestAct(); });}
			_displayHVSRAToggle = parentMVR.CreateToggle(parentMVR._hideVAMSaveRestoreActions, true); _displayHVSRAToggle.label = "Hide Save & Restore actions";
			if(_parent._currentActChooser.val.Substring(0,3)!="Act"){			
				string text ="";
				if(_parent._currentActChooser.val.Substring(0,10)=="Global Pre"){text="This Action will be triggered before the start of each Act";}
				if(_parent._currentActChooser.val.Substring(0,11)=="Global Post"){text="This Action will be triggered after the end of each Act";}
				JSONStorableString textBox = new JSONStorableString("textBox",text);_displayActTextField = parentMVR.CreateTextField(textBox,true);
			}			
			_displaySpacer = parentMVR.CreateSpacer(true); _displaySpacer.height = 200;
        }
        public int _randomActID ;	public int _actsSinceLastPlay ;	public bool _disableUIUpdates = false;public RandomAction _startAction ;public RandomAction _endAction ;public ActRandomizerV2 _parent;
		public JSONStorableFloat _actProbability ;	public JSONStorableFloat _durationMin ;	public JSONStorableFloat _durationMax;
        public UIDynamicSlider _displayProbabilityFloatSlider;public UIDynamicSlider _displayDurationMinFloatSlider;public UIDynamicSlider _displayDurationMaxFloatSlider;public UIDynamicButton _displayTestButton; public UIDynamicToggle _displayHVSRAToggle;public UIDynamicTextField _displayActTextField; public UIDynamic _displaySpacer;
    }
    public class RandomAction {
        public static Dictionary<string, string> MAPAtomTypeToDefaultReceiver = new Dictionary<string, string>()
        {{"Animation","AnimationPattern" },{"Sound","AudioSource" },{"Force","ForceProducer" },{"Light","Light" },{"Reflective","MirrorRender" },{"Triggers","Trigger" }};
        public RandomAction(int actID, string startOrEnd, RandomAct parentAct) {
            _atomName = new JSONStorableStringChooser("act" + actID.ToString() + "Atom" + startOrEnd + "Name", null, "", ""); _atomName.storeType = JSONStorableParam.StoreType.Full;
            _atomType = new JSONStorableString("act" + actID.ToString() + "Atom" + startOrEnd + "Type", "");_atomType.storeType = JSONStorableParam.StoreType.Full;
            _receiverGroupName = new JSONStorableStringChooser("act" + actID.ToString() + "Receiver" + startOrEnd + "GroupName", null, "", "");_receiverGroupName.storeType = JSONStorableParam.StoreType.Full;
            _receiverName = new JSONStorableStringChooser("act" + actID.ToString() + "Receiver" + startOrEnd + "Name", null, "", "");_receiverName.storeType = JSONStorableParam.StoreType.Full;
            _targetName = new JSONStorableStringChooser("act" + actID.ToString() + "Target" + startOrEnd + "Name", null, "", "");_targetName.storeType = JSONStorableParam.StoreType.Full;
            _targetType = new JSONStorableString("act" + actID.ToString() + "Action" + startOrEnd + "TypeName", "");_targetType.storeType = JSONStorableParam.StoreType.Full;
            _targetStringChooserValue = new JSONStorableStringChooser("act" + actID.ToString() + "Target" + startOrEnd + "ValueName", null, "", ""); _targetStringChooserValue.storeType = JSONStorableParam.StoreType.Full;
            _targetBoolValue = new JSONStorableBool("act" + actID.ToString() + "Target" + startOrEnd + "BoolValueName", false);_targetBoolValue.storeType = JSONStorableParam.StoreType.Full;
            _targetAudioCategory = new JSONStorableStringChooser("act" + actID.ToString() + "Target" + startOrEnd + "AudioCategory", null, "", "");_targetAudioCategory.storeType = JSONStorableParam.StoreType.Full;
            float defaultFloatVal;
            if (actID == 0) { defaultFloatVal = 0f; } else { defaultFloatVal = -1f; }
            _targetFloatValue = new JSONStorableFloat("act" + actID.ToString() + "Target" + startOrEnd + "FloatValueName", defaultFloatVal, 0f, 10000000f);_targetFloatValue.storeType = JSONStorableParam.StoreType.Full;
            HSVColor hsvColor; hsvColor.H = 0f; hsvColor.S = 0f; hsvColor.V = 0f;
            _targetColorValue = new JSONStorableColor("act" + actID.ToString() + "Target" + startOrEnd + "ColorValueName", hsvColor);_targetColorValue.storeType = JSONStorableParam.StoreType.Full;
            _targetFileURLValue = new JSONStorableString("act" + actID.ToString() + "Target" + startOrEnd + "FileURLValueName", ""); _targetFileURLValue.storeType = JSONStorableParam.StoreType.Full;
            _targetStringValue = new JSONStorableString("act" + actID.ToString() + "Target" + startOrEnd + "StringValueName", "",SelectText);_targetStringValue.storeType = JSONStorableParam.StoreType.Full; 
			_parentAct = parentAct;_isEndAction = (startOrEnd == "2");
        }
        public UIDynamicTextField CreateTextInput(JSONStorableString jss, bool rightSide = false){
			UIDynamicTextField textfield = _parentAct._parent.CreateTextField(jss, rightSide);var input = textfield.gameObject.AddComponent<InputField>();jss.inputField = input; input.lineType = InputField.LineType.MultiLineNewline;input.textComponent = textfield.UItext;input.textComponent.resizeTextMaxSize = 30;input.textComponent.resizeTextForBestFit = true;textfield.backgroundColor = Color.white;
			return(textfield);
		}
        public void ResetDefaults(string atomName){_atomName.val = atomName;Atom atom = GetActionAtom();  _atomType.val = atom.type; ResetReceiverName(false);}
        public void ResetReceiverName(bool updateUI) {
            string atomCategory = GetActionAtomCategory();
            if (atomCategory == "People"){SyncReceiverGroupChoices();if (!_receiverGroupName.choices.Contains(_receiverGroupName.val)){ _receiverGroupName.val = "Other";} }
            SyncReceiverChoices();
            if (!_receiverName.choices.Contains(_receiverName.val)){
                if (atomCategory == "People") {
                    if (_receiverGroupName.val == "Other") { _receiverName.val = "Load Look/Pose/Preset"; }else { _receiverName.val = _receiverName.choices[0]; }
                }
                else {
                    string defaultReceiver = null;MAPAtomTypeToDefaultReceiver.TryGetValue(GetActionAtomCategory(), out defaultReceiver);
                    if (defaultReceiver == null) { _receiverName.val = _receiverName.choices[0]; } else { _receiverName.val = defaultReceiver; }
                }
            }
            ResetTargetName(false);
            if (updateUI) { _parentAct.initRandomActUI(); }
        }
        public void ResetTargetName(bool updateUI){
            SyncTargetChoices();
            if (!_targetName.choices.Contains(_targetName.val)) { _targetName.val = _targetName.choices[0]; _previousTargetType = _targetType.val;_targetType.val = GetTargetType();}
            ResetTargetValue(false);
            if (updateUI) { _parentAct.initRandomActUI(); }
        }
        public void ResetTargetValue(bool updateUI,string previousTargetType=""){
            JSONStorable receiver; receiver = GetActionReceiver();
            if (_targetType.val == "BOOL") {JSONStorableBool actionBoolJSON = receiver.GetBoolJSONParam(_targetName.val);_targetBoolValue.val = actionBoolJSON.val;}
            else if (_targetType.val == "CHOICE"){JSONStorableStringChooser actionStringChoiceJSON = receiver.GetStringChooserJSONParam(_targetName.val);_targetStringChooserValue.val = actionStringChoiceJSON.val;}
            else if (_targetType.val == "FLOAT") {JSONStorableFloat actionFloatJSON = receiver.GetFloatJSONParam(_targetName.val); _targetFloatValue.min = actionFloatJSON.min;_targetFloatValue.max = actionFloatJSON.max;_targetFloatValue.constrained = actionFloatJSON.constrained;_targetFloatValue.val = actionFloatJSON.val;_targetFloatValue.defaultVal = actionFloatJSON.defaultVal;}
            else if (_targetType.val == "COLOR"){JSONStorableColor actionColorJSON = receiver.GetColorJSONParam(_targetName.val);_targetColorValue.val = actionColorJSON.val;  }
            else if (_targetType.val == "URL") {JSONStorableUrl actionUrlJSON = receiver.GetUrlJSONParam(_targetName.val); _targetFileURLValue.val = actionUrlJSON.val; }
            else if (_targetType.val == "STRING"){JSONStorableString actionStringJSON = receiver.GetStringJSONParam(_targetName.val); _targetStringValue.val = actionStringJSON.val;}
            else if (_targetType.val == "AUDIO"){
                SyncAudioCategoryChoices ();
                if (!_targetAudioCategory.choices.Contains(_targetAudioCategory.val)){ _targetAudioCategory.val = _targetAudioCategory.choices[0];SelectAudioCategory(_targetAudioCategory.val); }
                SyncTargetValueChoices();
                if (!_targetStringChooserValue.choices.Contains(_targetStringChooserValue.val)) { _targetStringChooserValue.val = _targetStringChooserValue.choices[0]; SelectTargetString(_targetStringChooserValue.val); }
            }
            else{
                if (previousTargetType != _targetType.val){
                    //TBD - not quite sure what this for?
                    //_target1ValueFilePathStringJSON.val = ""; Target1FileURLValueSelect(""); 
                }
            } 
            if (updateUI) { _parentAct.initRandomActUI(); }
        }
        public string GetTargetType() {
            string targetType = "UNKNOWN";
            if (_receiverName.val == "Load Look/Pose/Preset" || _receiverName.val == "Dress/Undress Clothing"){
                if (_targetName.val != "NO ACTION") { targetType = ActRandomizerV2.MAPToTargetType[_targetName.val]; }
                else { targetType = "LOAD"; }
            }
            else {
                JSONStorable receiver = GetActionReceiver();
                if (receiver != null){
                    if (receiver.IsBoolJSONParam(_targetName.val)) { targetType = "BOOL"; }
                    else if (receiver.IsStringChooserJSONParam(_targetName.val)) { targetType = "CHOICE"; }
                    else if (receiver.IsFloatJSONParam(_targetName.val)) { targetType = "FLOAT"; }
                    else if (receiver.IsAudioClipAction(_targetName.val)) { targetType = "AUDIO"; }
                    else if (receiver.IsAction(_targetName.val)) { targetType = "ACTION"; }
                    else if (receiver.IsColorJSONParam(_targetName.val)) { targetType = "COLOR"; }
                    else if (receiver.IsUrlJSONParam(_targetName.val)) { targetType = "URL"; }
                    else if (receiver.IsStringJSONParam(_targetName.val)) { targetType = "STRING"; }
                    else { targetType = "OTHER"; }
                }
            }
            return (targetType);
        }
        public void RegisterRandomAction() { ActRandomizerV2 parentMVR = _parentAct._parent;parentMVR.RegisterStringChooser(_atomName);parentMVR.RegisterString(_atomType);parentMVR.RegisterStringChooser(_receiverGroupName);parentMVR.RegisterStringChooser(_receiverName);parentMVR.RegisterStringChooser(_targetName); parentMVR.RegisterString(_targetType);parentMVR.RegisterStringChooser(_targetStringChooserValue);parentMVR.RegisterStringChooser(_targetAudioCategory);parentMVR.RegisterBool(_targetBoolValue);parentMVR.RegisterFloat(_targetFloatValue);parentMVR.RegisterColor(_targetColorValue);parentMVR.RegisterString(_targetFileURLValue);parentMVR.RegisterString(_targetStringValue);}
        public void DeregisterRandomAction() { ActRandomizerV2 parentMVR = _parentAct._parent;parentMVR.DeregisterStringChooser(_atomName);parentMVR.DeregisterString(_atomType);parentMVR.DeregisterStringChooser(_receiverGroupName);parentMVR.DeregisterStringChooser(_receiverName);parentMVR.DeregisterStringChooser(_targetName);parentMVR.DeregisterString(_targetType);parentMVR.DeregisterStringChooser(_targetStringChooserValue);parentMVR.DeregisterStringChooser(_targetAudioCategory);parentMVR.DeregisterFloat(_targetFloatValue);parentMVR.DeregisterBool(_targetBoolValue);parentMVR.DeregisterColor(_targetColorValue);parentMVR.DeregisterString(_targetFileURLValue);parentMVR.DeregisterString(_targetStringValue);}
        public void CopyActionFrom(RandomAction randomAction) {_atomName.val = randomAction._atomName.val;_atomType.val = randomAction._atomType.val; _receiverGroupName.val = randomAction._receiverGroupName.val;_receiverName.val = randomAction._receiverName.val;_targetName.val = randomAction._targetName.val;_targetType.val = randomAction._targetType.val;_targetStringChooserValue.val = randomAction._targetStringChooserValue.val; _targetAudioCategory.val = randomAction._targetAudioCategory.val;_targetFloatValue.min = randomAction._targetFloatValue.min;_targetFloatValue.max = randomAction._targetFloatValue.max;_targetFloatValue.constrained = randomAction._targetFloatValue.constrained;_targetFloatValue.val = randomAction._targetFloatValue.val;_targetBoolValue.val = randomAction._targetBoolValue.val;_targetColorValue.val = randomAction._targetColorValue.val; _targetFileURLValue.val = randomAction._targetFileURLValue.val;_targetStringValue.val = randomAction._targetStringValue.val;_isEndAction = randomAction._isEndAction;}
        public void RestoreFromJSON(int index, string startOrEnd, JSONNode actSaveJSON) {
            _atomName.val = actSaveJSON["act" + index.ToString() + "Atom" + startOrEnd + "Name"].Value; _atomType.val = actSaveJSON["act" + index.ToString() + "Atom" + startOrEnd + "Type"].Value; _receiverGroupName.val = actSaveJSON["act" + index.ToString() + "Receiver" + startOrEnd + "GroupName"].Value; _receiverName.val = actSaveJSON["act" + index.ToString() + "Receiver" + startOrEnd + "Name"].Value;_targetName.val = actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "Name"].Value;_targetType.val = actSaveJSON["act" + index.ToString() + "Action" + startOrEnd + "TypeName"].Value;
            if (actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "ValueName"] == null) { _targetStringChooserValue.val = ""; }
            else { _targetStringChooserValue.val = actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "ValueName"].Value; }
            if (actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "AudioCategory"] == null) { _targetAudioCategory.val = ""; }
            else { _targetAudioCategory.val = actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "AudioCategory"].Value; }
            if (actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "BoolValueName"] == null) { _targetBoolValue.val = false; }
            else { _targetBoolValue.val = actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "BoolValueName"].AsBool; }
			
			JSONStorable receiver = GetActionReceiver();
			if (receiver!=null){
				JSONStorableFloat actionFloatJSON = receiver.GetFloatJSONParam(_targetName.val);
				if (actionFloatJSON!=null){
					_targetFloatValue.min = actionFloatJSON.min;
					_targetFloatValue.max = actionFloatJSON.max;
					_targetFloatValue.constrained = actionFloatJSON.constrained;
				}
			}
			
            if (actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "FloatValueName"] == null) { _targetFloatValue.val = 0f; }
            else { _targetFloatValue.val = actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "FloatValueName"].AsFloat; }
            HSVColor tempColor;
            if (actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "ColorValueName"] == null) { tempColor.H = 0f; tempColor.S = 0f; tempColor.V = 0f; }
            else { tempColor.H = actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "ColorValueName"]["h"].AsFloat;tempColor.S = actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "ColorValueName"]["s"].AsFloat;tempColor.V = actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "ColorValueName"]["v"].AsFloat;}
            _targetColorValue.val = tempColor;_targetFileURLValue.val = actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "FileURLValueName"].Value; _targetStringValue.val = actSaveJSON["act" + index.ToString() + "Target" + startOrEnd + "StringValueName"].Value; _isEndAction = (startOrEnd == "2");
        }

        public void initRandomActionUI(){
            ActRandomizerV2 parentMVR = _parentAct._parent;string labelPostFix ="";
            if (_isEndAction) { labelPostFix = "(End Act)"; }
			if (_parentAct._parent._currentActChooser.val.Substring(0,3)!="Act"){
				if(_parentAct._parent._currentActChooser.val.Substring(0,10)!="Global Pre"){labelPostFix = "(Pre Act)"; }
				if(_parentAct._parent._currentActChooser.val.Substring(0,11)!="Global Post"){labelPostFix = "(Post Act)"; }
			}
            else { labelPostFix = "(Start Act)"; }
			if (_displayAtomPopup !=null){parentMVR.RemovePopup(_displayAtomPopup);}
            if (_displayReceiverGroupPopup != null) { parentMVR.RemovePopup(_displayReceiverGroupPopup); }
            if (_displayReceiverPopup != null) { parentMVR.RemovePopup(_displayReceiverPopup); }
            if (_displayTargetPopup != null) { parentMVR.RemovePopup(_displayTargetPopup); }
            if (_displayTargetValuePopup != null) { parentMVR.RemovePopup(_displayTargetValuePopup); }
            if (_displayTargetValueFloatSlider != null) { parentMVR.RemoveSlider( _displayTargetValueFloatSlider); }
            if (_displayTargetValueColorPopup != null) { parentMVR.RemoveColorPicker(_displayTargetValueColorPopup); }
            if (_displayFileSelectButton != null) { parentMVR.RemoveButton(_displayFileSelectButton); }
            if (_displayClearFileSelectButton != null) { parentMVR.RemoveButton(_displayClearFileSelectButton); }
            if (_displayTargetStringURL != null) { parentMVR.RemoveTextField(_displayTargetStringURL); }
            if (_displayTargetValueBoolToggle != null) { parentMVR.RemoveToggle(_displayTargetValueBoolToggle); }
            if (_displayAudioCategoryPopup != null) { parentMVR.RemovePopup(_displayAudioCategoryPopup); }			
			if(_parentAct._parent._currentActChooser.val.Substring(0,3)=="Act" || !_isEndAction){_displayAtomPopup = parentMVR.CreateSetupScrollablePopup(_atomName,true,580f,this.SyncAtomChoices,"Atom\n"+labelPostFix);_displayAtomPopup.popup.onValueChangeHandlers +=SelectAtomName;initRandomActionReceiverUI();}
        }
        public void initRandomActionReceiverUI(){
            ActRandomizerV2 parentMVR = _parentAct._parent;string labelPostFix = "";
            if (_isEndAction) { labelPostFix = "(End Act)"; }
            else { labelPostFix = "(Start Act)"; }
            if (GetActionAtomCategory() == "People"){ _displayReceiverGroupPopup = parentMVR.CreateSetupScrollablePopup(_receiverGroupName, true, 570f, this.SyncReceiverGroupChoices, "Receiver Group\n" + labelPostFix);_displayReceiverGroupPopup.popup.onValueChangeHandlers += SelectReceiverGroup;}
            _displayReceiverPopup = parentMVR.CreateSetupScrollablePopup(_receiverName, true, 460f, this.SyncReceiverChoices, "Receiver\n" + labelPostFix);_displayReceiverPopup.popup.onValueChangeHandlers += SelectReceiver;initRandomActionTargetUI();
        }
        public void initRandomActionTargetUI(){
            ActRandomizerV2 parentMVR = _parentAct._parent;string labelPostFix = "";
            if (_isEndAction) { labelPostFix = "(End Act)"; } else { labelPostFix = "(Start Act)"; }
            _displayTargetPopup = parentMVR.CreateSetupScrollablePopup(_targetName, true, 370f, this.SyncTargetChoices, "Target\n" + labelPostFix);_displayTargetPopup.popup.onValueChangeHandlers += SelectTarget;
            if (_targetType.val == "FLOAT") { _displayTargetValueFloatSlider = parentMVR.CreateSlider(_targetFloatValue, true); _displayTargetValueFloatSlider.slider.onValueChanged.AddListener((float val) => { this.SelectTargetFloat(val); });_displayTargetValueFloatSlider.label = _targetName.val + " Value"; }
            else if (_targetType.val == "COLOR") {_displayTargetValueColorPopup = parentMVR.CreateColorPicker(_targetColorValue, true); _displayTargetValueColorPopup.colorPicker.onColorChangedHandlers += SelectTargetColor;_displayTargetValueColorPopup.label = _targetName.val + " Color";}
            else if (_targetType.val == "BOOL") {_displayTargetValueBoolToggle = parentMVR.CreateToggle(_targetBoolValue, true); _displayTargetValueBoolToggle.toggle.onValueChanged.AddListener((bool val) => { this.SelectTargetBool(val); }); _displayTargetValueBoolToggle.label = " Enable " + _targetName.val; }
            else if ((_receiverName.val == "Load Look/Pose/Preset" || _receiverName.val == "Dress/Undress Clothing" || _targetType.val == "URL") && _targetName.val != "NO ACTION"){
                _displayTargetStringURL = parentMVR.CreateTextField(_targetFileURLValue, true);_displayTargetStringURL.height = 1;_displayFileSelectButton = parentMVR.CreateButton("File Selection", true);
                _displayFileSelectButton.button.onClick.AddListener(() => {
                    //SuperController.singleton.NormalizeMediaPath (_lastBrowseDir); // This sets the path if it exists
                    string filetype = ""; string folder = "";
					if (_targetType.val == "URL") { filetype = ""; folder = "Custom\\Atom\\Person\\Textures"; }
                    else{
						filetype = ActRandomizerV2.MAPTargetType[_targetType.val].fileType;
						folder = ActRandomizerV2.MAPTargetType[_targetType.val].defaultFolder;}
                    SuperController.singleton.GetMediaPathDialog(SelectFile, filetype, folder,false,true,false);
                });
                _displayClearFileSelectButton = parentMVR.CreateButton("Clear File Selection", true); _displayClearFileSelectButton.button.onClick.AddListener(() => { this.SelectFile(""); });
            }
            else if (_targetType.val == "STRING" ) {
				_displayTargetStringURL = CreateTextInput(_targetStringValue, true); _displayTargetStringURL.height = 1;	
			}
            else if(_targetType.val != "ACTION" && _targetName.val!="NO ACTION") {
                if (_targetType.val == "AUDIO") {
                    _displayAudioCategoryPopup = parentMVR.CreateSetupScrollablePopup(_targetAudioCategory, true, 460f, this.SyncAudioCategoryChoices, "Audio Category");
					_displayAudioCategoryPopup.popup.onValueChangeHandlers += SelectAudioCategory; _displayAudioCategoryPopup.label = "Audio Category";
                }
                _displayTargetValuePopup = parentMVR.CreateSetupScrollablePopup(_targetStringChooserValue, true, 350f, this.SyncTargetValueChoices, "Target Value");_displayTargetValuePopup.popup.onValueChangeHandlers += SelectTargetString;_displayTargetValuePopup.label = "Target Selection";
            }
        }
        public void SyncAtomChoices(){
            List<string> atomChoices = new List<string>();ActRandomizerV2.CloseAllPopup(_displayAtomPopup);atomChoices.Add("<CONTAINING ATOM>");
            foreach (string atomUID in SuperController.singleton.GetAtomUIDs()) { atomChoices.Add(atomUID); }
            _atomName.choices = atomChoices;
        }
        public void SelectAtomName (string atomName){
            try {
                Atom atom = GetActionAtom();_atomType.val = atom.type;ResetReceiverName(true);
                if (!_isEndAction && _parentAct._endAction._targetName.val == "NO ACTION") { _parentAct._endAction._atomName.val = _atomName.val; _parentAct._endAction.SelectAtomName(_atomName.val); }
                if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectReceiverGroup(string groupName){
            try{
                ResetReceiverName(true); RandomAction endAction = _parentAct._endAction;
                if (!_isEndAction && endAction._targetName.val == "NO ACTION" && endAction._atomName.val == _atomName.val) { endAction._receiverGroupName.val = _receiverGroupName.val; endAction.SelectReceiverGroup(_receiverGroupName.val); }
                if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectReceiver(string receiver){
            try{
                ResetTargetName(true); RandomAction endAction = _parentAct._endAction;
                if (!_isEndAction && endAction._targetName.val == "NO ACTION" && endAction._atomName.val == _atomName.val) { 
                    endAction._receiverGroupName.val = _receiverGroupName.val; endAction.SelectReceiverGroup(_receiverGroupName.val);endAction._receiverName.val = _receiverName.val;endAction.SelectReceiver(_receiverName.val);
                }
                if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  
            }
            catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectTarget(string target){
            try{
                _targetType.val = GetTargetType(); ResetTargetValue(true);
                if (!_isEndAction){
                    if (_receiverName.val.Contains("VisemeAligner") && _targetName.val.StartsWith("Speak")){
                        string clipName = _targetName.val.Substring(6);NamedAudioClip nac = URLAudioClipManager.singleton.GetClip(clipName);
                        if (nac != null) { AudioClip audioClip = nac.clipToPlay;float audioClipLength = audioClip.length;_parentAct._durationMin.val = 0; _parentAct._durationMax.val = audioClipLength; _parentAct._durationMin.val = audioClipLength;}
                    }
                    if (_receiverName.val == "AnimationPattern" && (_targetName.val == "Play" || _targetName.val == "ResetAndPlay")) {AnimationPattern apReceiver = GetActionAtom().animationPatterns[0];float apLength = apReceiver.GetTotalTime();_parentAct._durationMin.val = 0; _parentAct._durationMax.val = apLength; _parentAct._durationMin.val = apLength; }
                }
                if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectTargetString(string value){
            try {
                if (!_isEndAction && _targetType.val =="AUDIO"){
                    NamedAudioClip nac = _parentAct._parent.GetAudioClip(_targetAudioCategory.val,value);
                    if (nac != null){AudioClip audioClip = nac.clipToPlay;float audioClipLength = audioClip.length;_parentAct._durationMin.val = 0; _parentAct._durationMax.val = audioClipLength; _parentAct._durationMin.val = audioClipLength;}
                }
                if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectTargetBool(bool value){
            try {if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  }
            catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectTargetColor(Color value) {
            try {
                HSVColor newcolor;Color.RGBToHSV(value,out newcolor.H, out newcolor.S, out newcolor.V); _targetColorValue.val = newcolor;
                if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  
            }
            catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectTargetFloat(float value) {
            try{if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  }
            catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectAudioCategory(string receiver){
            try{ResetTargetValue(false);  if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectFile(string fileName) {
			try{
                string relFilePath;
                if (fileName!=""){
                    if (String.IsNullOrEmpty(fileName)) { return; }
                    
                   _targetFileURLValue.val = fileName;
                }
				else{_targetFileURLValue.val ="";}
                if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  
			}catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SelectText(string fileName){
			try{
                if (!_disableUIUpdates) { _parentAct._parent.SaveUIAct(); }  
			}catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
        public void SyncReceiverGroupChoices(){
            List<string> receiverGroupChoices = new List<string>();ActRandomizerV2.CloseAllPopup(_displayReceiverGroupPopup);receiverGroupChoices.Add("Node Controls"); receiverGroupChoices.Add("Node Animations"); receiverGroupChoices.Add("Collision Triggers"); receiverGroupChoices.Add("Hair"); receiverGroupChoices.Add("Clothing"); receiverGroupChoices.Add("Skin & Eyes");
            if (GetActionAtom() != null){
                List<string> receivers = GetActionAtom().GetStorableIDs();int countPlugins = 0;
                foreach (string receiver in receivers) { if (receiver.Contains("plugin#")) { countPlugins++; } }
                if (countPlugins > 0) { receiverGroupChoices.Add("Plugins"); }
            }
            receiverGroupChoices.Add("Physics"); receiverGroupChoices.Add("Presets"); receiverGroupChoices.Add("Speech"); receiverGroupChoices.Add("Morphs"); receiverGroupChoices.Add("Other"); _receiverGroupName.choices = receiverGroupChoices;
        }
		public void SyncReceiverChoices(){
            List<string> receiverChoices = new List<string>();ActRandomizerV2.CloseAllPopup(_displayReceiverPopup); Atom atom = GetActionAtom();
            if (atom != null){
                if ((_receiverGroupName.val == "Clothing" || _receiverGroupName.val == "Hair" || _receiverGroupName.val == "Physics" || _receiverGroupName.val == "Skin & Eyes" || _receiverGroupName.val == "Morphs") && atom.category == "People") { receiverChoices.Add("geometry"); }
                if (_receiverGroupName.val == "Other" && atom.category == "People") { receiverChoices.Add("Load Look/Pose/Preset"); receiverChoices.Add("Dress/Undress Clothing"); }
                foreach (string receiverChoice in atom.GetStorableIDs()){
                    JSONStorable receiver = GetActionAtom().GetStorableByID(receiverChoice);
                    if (receiver.GetAllParamAndActionNames().Count > 15){
                        if (atom.category != "People") { receiverChoices.Add(receiverChoice); }
                        else{
                            bool foundReceiver = false;
                            foreach (KeyValuePair<string, string> entry in ActRandomizerV2.MAPReceiversToGroups) {
                                if (receiverChoice.Contains(entry.Key)){foundReceiver = true;if (_receiverGroupName.val == entry.Value) { receiverChoices.Add(receiverChoice); }break;}
                            }
                            if (!foundReceiver) { if (_receiverGroupName.val == "Other" && receiverChoice!="geometry") { receiverChoices.Add(receiverChoice); } }
                        }
                    }
                }
            }
            _receiverName.choices = receiverChoices;
        }
		public void SyncTargetChoices(){
			List<string> choices = new List<string>(); ActRandomizerV2.CloseAllPopup(_displayTargetPopup);
            if (_receiverName.val == "Load Look/Pose/Preset" || _receiverName.val == "Dress/Undress Clothing") {
                if (_isEndAction) { choices.Add("NO ACTION"); }
                foreach (KeyValuePair<string, string> entry in ActRandomizerV2.MAPToTargetType){
                    if (_receiverName.val == "Dress/Undress Clothing" && entry.Value== "LOADCLOTHPRESET") { choices.Add(entry.Key); }
                    else if (_receiverName.val == "Load Look/Pose/Preset" && (entry.Value != "LOADCLOTHPRESET"||entry.Key =="Load Clothing Preset")) { choices.Add(entry.Key); }
                }
			}
			else {
				JSONStorable receiver = GetActionReceiver ();
				if (receiver!=null){
					if (_isEndAction) {choices.Add("NO ACTION");}
					List<string> targetParamNames = new List<string>();targetParamNames = receiver.GetAllParamAndActionNames();
					foreach (string paramName in targetParamNames){
						if(!ActRandomizerV2.VAMSaveRestoreActions.Contains(paramName) || !_parentAct._parent._hideVAMSaveRestoreActions.val){
							if (GetActionAtomCategory()=="People" && _receiverName.val =="geometry" ){
								bool isParamNameInOtherGroup = true;
								foreach (KeyValuePair<string, string> entry in ActRandomizerV2.MAPReceiverGeometryParamsToGroup){
									if (paramName.Contains(entry.Key)){isParamNameInOtherGroup = false;
										if (_receiverGroupName.val == entry.Value ){choices.Add(paramName);}
									}
								}
								if (isParamNameInOtherGroup && _receiverGroupName.val =="Morphs"){choices.Add(paramName);}
							}
							else{choices.Add(paramName);}
						}
					}
				}
			}
            if (choices.Count == 0) { choices.Add("NO TARGET AVAILABLE"); }
			_targetName.choices = choices;	
		}
		public void SyncAudioCategoryChoices(){
            try{ActRandomizerV2.CloseAllPopup(_displayAudioCategoryPopup); _targetAudioCategory.choices = _parentAct._parent.GetAudioCategoryChoices();
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
		public void SyncTargetValueChoices(){
            try{
                List<string> choices = new List<string>();ActRandomizerV2.CloseAllPopup(_displayTargetValuePopup);
                if (_targetType.val == "CHOICE"){
                    JSONStorableStringChooser targetStringChooserJSON = GetActionReceiver().GetStringChooserJSONParam(_targetName.val);
                    foreach (string choice in targetStringChooserJSON.choices) { choices.Add(choice); }
                }
                else if (_targetType.val == "AUDIO"){choices = _parentAct._parent.GetAudioClipChoices(_targetAudioCategory.val);}
                _targetStringChooserValue.choices = choices;
            }catch (Exception e) { SuperController.LogError("Exception caught: " + e); }
        }
		public Atom GetActionAtom(){if (_atomName.val=="<CONTAINING ATOM>"){return(_parentAct._parent.containingAtom);}else {return (SuperController.singleton.GetAtomByUid(_atomName.val));}}
        public string GetActionAtomCategory(){Atom atom = GetActionAtom();string atomCategory = "";if (atom!=null){atomCategory = atom.category;}return (atomCategory);}
		public string GetActionAtomType(){Atom atom = GetActionAtom();string atomType = "";if (atom!=null){atomType = atom.type;}return (atomType);}
		public JSONStorable GetActionReceiver (){Atom atom = GetActionAtom();if (atom !=null) {return (atom.GetStorableByID(_receiverName.val));}return (null);}
        public void CloseAllPopup(UIDynamicPopup exception){
            if (_displayAtomPopup!=null && _displayAtomPopup != exception) { _displayAtomPopup.popup.visible = false; }
            if (_displayReceiverGroupPopup != null && _displayReceiverGroupPopup != exception) { _displayReceiverGroupPopup.popup.visible = false; }
            if (_displayReceiverPopup != null && _displayReceiverPopup != exception) { _displayReceiverPopup.popup.visible = false; }
            if (_displayTargetPopup != null && _displayTargetPopup != exception) { _displayTargetPopup.popup.visible = false; }
            if (_displayTargetValuePopup != null && _displayTargetValuePopup != exception) { _displayTargetValuePopup.popup.visible = false; }
            if (_displayAudioCategoryPopup != null && _displayAudioCategoryPopup != exception) { _displayAudioCategoryPopup.popup.visible = false; }
        }
		protected void MergePreset( Atom atom, string fileName, bool reverse = false, string specialMode = "NONE"){
			JSONNode presetJSON = _parentAct._parent.LoadJSON(fileName);JSONArray storablesJSON=presetJSON["storables"].AsArray ;
			for (int index = 0; index < storablesJSON.Count; index++){
				if ((string)storablesJSON[index]["id"]=="geometry") {
					JSONStorable receiver = atom.GetStorableByID("geometry");JSONArray clothingJSON=storablesJSON[index]["clothing"].AsArray ;
					for (int clothingIndex = 0; clothingIndex < clothingJSON.Count; clothingIndex++){
						JSONStorableBool clothingEnabled = receiver.GetBoolJSONParam("clothing:"+clothingJSON[clothingIndex]["id"]);
						if((string)clothingJSON[clothingIndex]["enabled"]=="true"&& specialMode=="NONE"){ clothingEnabled.val = !reverse;}
					}					
				}
				else if (!reverse || specialMode!="NONE"){
					JSONStorable receiver = atom.GetStorableByID((string)storablesJSON[index]["id"]);
					foreach (string boolParamName in receiver.GetBoolParamNames()){
						if (storablesJSON[index][boolParamName]!=null&& specialMode=="NONE"){receiver.GetBoolJSONParam(boolParamName).val=((string)storablesJSON[index][boolParamName]=="true");}
						if (boolParamName=="allowDetach" && specialMode =="UNDRESS"){receiver.GetBoolJSONParam(boolParamName).val=!reverse;}
						if (boolParamName=="simEnabled" && specialMode =="RESETSIM"){receiver.CallAction("Reset");}
					}
					foreach (string colorParamName in receiver.GetColorParamNames()){
						if (storablesJSON[index][colorParamName]!=null){HSVColor color ;color.H = storablesJSON[index][colorParamName]["h"].AsFloat;color.S = storablesJSON[index][colorParamName]["s"].AsFloat;color.V = storablesJSON[index][colorParamName]["v"].AsFloat;receiver.GetColorJSONParam(colorParamName).val=color;}
					}
					foreach (string floatParamName in receiver.GetFloatParamNames()){
						if (storablesJSON[index][floatParamName]!=null){receiver.GetFloatJSONParam(floatParamName).val=storablesJSON[index][floatParamName].AsFloat;}
					}
					foreach (string stringParamName in receiver.GetStringParamNames()){
						if (storablesJSON[index][stringParamName]!=null){receiver.GetStringJSONParam(stringParamName).val=storablesJSON[index][stringParamName];}
					}
					foreach (string stringChooserParamName in receiver.GetStringChooserParamNames()){
						if (storablesJSON[index][stringChooserParamName]!=null){receiver.GetStringChooserJSONParam(stringChooserParamName).val=storablesJSON[index][stringChooserParamName];}
					}
					foreach (string urlParamName in receiver.GetUrlParamNames()){
						if (storablesJSON[index][urlParamName]!=null){receiver.GetUrlJSONParam(urlParamName).val=storablesJSON[index][urlParamName];}
					}
					foreach (string vector3ParamName in receiver.GetVector3ParamNames()){
						if (storablesJSON[index][vector3ParamName]!=null){Vector3 vector ;JSONArray vector3Array = storablesJSON[index][vector3ParamName].AsArray ;vector.x = vector3Array[0].AsFloat;vector.y = vector3Array[1].AsFloat;vector.z = vector3Array[2].AsFloat;receiver.GetVector3JSONParam(vector3ParamName).val=vector;}
					}					
				}
			}
		}
		public void PlayAction(){
			Atom nextActionAtom =null;JSONStorable nextActionReceiver = null;nextActionAtom = GetActionAtom();
			if (nextActionAtom == null)	{SuperController.LogMessage("Act Randomizer ("+_parentAct._parent.storeId+") was unable to load Atom ("+_atomName.val+") for Action "+_parentAct._randomActID.ToString());}
			else if (_targetType.val.Substring(0,Math.Min(4, _targetType.val.Length))!="LOAD" && _targetType.val.Substring(0, Math.Min(5, _targetType.val.Length)) !="MERGE" ){nextActionReceiver = nextActionAtom.GetStorableByID (_receiverName.val);}
			if (nextActionReceiver == null && _targetType.val.Substring(0,4)!="LOAD" && _targetType.val.Substring(0,5)!="MERGE" ){SuperController.LogMessage("Act Randomizer ("+_parentAct._parent.storeId+") was unable to load Receiver ("+_receiverName.val+") for Action "+_parentAct._randomActID.ToString());}
			else {
				if(_targetType.val == "ACTION"){nextActionReceiver.CallAction (_targetName.val);}
				else if(_targetType.val == "AUDIO"){
					AudioSourceControl source = nextActionReceiver as AudioSourceControl;NamedAudioClip clip = _parentAct._parent.GetAudioClip(_targetAudioCategory.val,_targetStringChooserValue.val);
					if (clip == null) {SuperController.LogMessage("Act Randmomizer ("+_parentAct._parent.storeId+") was unable to load Audio Clip ("+_targetStringChooserValue.val+")");}
					else{if (_targetName.val == "PlayNow"){source.PlayNow(clip);}if (_targetName.val == "PlayIfClear"){source.PlayIfClear(clip);}if (_targetName.val == "PlayNowLoop"){source.PlayNowLoop(clip);}if (_targetName.val == "PlayNowClearQueue"){source.PlayNowClearQueue(clip);}if (_targetName.val == "PlayNext"){source.PlayNext(clip);}if (_targetName.val == "PlayNextClearQueue"){source.PlayNextClearQueue(clip);}if (_targetName.val == "Queue"){source.QueueClip(clip);}}
				}
				else if(_targetType.val == "BOOL"){
					JSONStorableBool actionBoolJSON = nextActionReceiver.GetBoolJSONParam(_targetName.val) ;
					if (actionBoolJSON == null) {SuperController.LogMessage("Act Randmomizer ("+_parentAct._parent.storeId+") was unable to load target ("+_targetName.val+")");}
					else {if(_targetBoolValue.val){actionBoolJSON.val = true;}else{actionBoolJSON.val = false;}}
				}
				else if (_targetType.val == "CHOICE"){
					JSONStorableStringChooser actionStringChoiceJSON = nextActionReceiver.GetStringChooserJSONParam(_targetName.val) ;
					if (actionStringChoiceJSON == null) {SuperController.LogMessage("Act Randmomizer ("+_parentAct._parent.storeId+") was unable to load target ("+_targetName.val+")");}
					else {actionStringChoiceJSON.val = _targetStringChooserValue.val;}
				}	
				else if (_targetType.val == "COLOR"){
					JSONStorableColor actionColorChoiceJSON = nextActionReceiver.GetColorJSONParam(_targetName.val) ;
					if (actionColorChoiceJSON == null) {SuperController.LogMessage("Act Randmomizer ("+_parentAct._parent.storeId+") was unable to load target ("+_targetName.val+")");}
					else {actionColorChoiceJSON.val = _targetColorValue.val;}
				}	
				else if (_targetType.val == "FLOAT"){
					JSONStorableFloat actionFloatValueJSON = nextActionReceiver.GetFloatJSONParam(_targetName.val) ;
					if (actionFloatValueJSON == null) {SuperController.LogMessage("Act Randmomizer ("+_parentAct._parent.storeId+") was unable to load target ("+_targetName.val+")");}
					else {actionFloatValueJSON.val = _targetFloatValue.val;}
				}
				else if (_targetType.val == "URL"){
                    JSONStorableUrl actionUrlValueJSON = nextActionReceiver.GetUrlJSONParam(_targetName.val) ;
					if (actionUrlValueJSON == null) {SuperController.LogMessage("Act Randmomizer ("+_parentAct._parent.storeId+") was unable to load target ("+_targetName.val+")");}
					else {
						try{actionUrlValueJSON.val = _targetFileURLValue.val;}
						catch (Exception e) {SuperController.LogMessage("Act Randmomizer ("+_parentAct._parent.storeId+") was unable to load target ("+_targetName.val+") due to the  invalid filename '"+_targetFileURLValue.val+"'");}
					}
				}
				else if (_targetType.val == "STRING"){
					JSONStorableString actionStringValueJSON = nextActionReceiver.GetStringJSONParam(_targetName.val) ;
					if (actionStringValueJSON == null) {SuperController.LogMessage("Act Randmomizer ("+_parentAct._parent.storeId+") was unable to load target ("+_targetName.val+")");}
					else {actionStringValueJSON.val = _targetStringValue.val;}
				}
				else if (_targetType.val == "LOADLOOK"){if(_targetFileURLValue.val!=""&&_targetFileURLValue.val!="n/a"){nextActionAtom.LoadAppearancePreset(ActRandomizerV2._vamFilePath+_targetFileURLValue.val);}}
				else if (_targetType.val == "LOADPOSE"){if(_targetFileURLValue.val!=""&&_targetFileURLValue.val!="n/a"){nextActionAtom.LoadPhysicalPreset(ActRandomizerV2._vamFilePath+_targetFileURLValue.val);}}
				else if (_targetType.val == "LOADPRESET"){if(_targetFileURLValue.val!=""&&_targetFileURLValue.val!="n/a"){nextActionAtom.LoadPreset(ActRandomizerV2._vamFilePath+_targetFileURLValue.val);}}
				else if (_targetName.val == "Merge Clothing Preset"){if(_targetFileURLValue.val!=""&&_targetFileURLValue.val!="n/a"){MergePreset (nextActionAtom, ActRandomizerV2._vamFilePath+_targetFileURLValue.val);}}
				else if (_targetName.val == "Remove Clothing Preset"){if(_targetFileURLValue.val!=""&&_targetFileURLValue.val!="n/a"){MergePreset (nextActionAtom, ActRandomizerV2._vamFilePath+_targetFileURLValue.val, true);}}
				else if (_targetName.val == "Reset Sim Cloth Preset"){if(_targetFileURLValue.val!=""&&_targetFileURLValue.val!="n/a"){MergePreset (nextActionAtom, ActRandomizerV2._vamFilePath+_targetFileURLValue.val, false,"RESETSIM");}}
				else if (_targetName.val == "Sim Undress Cloth Preset"){if(_targetFileURLValue.val!=""&&_targetFileURLValue.val!="n/a"){MergePreset (nextActionAtom, ActRandomizerV2._vamFilePath+_targetFileURLValue.val, false,"UNDRESS");}}
				else if (_targetName.val == "Sim Dress Cloth Preset"){if(_targetFileURLValue.val!=""&&_targetFileURLValue.val!="n/a"){MergePreset (nextActionAtom, ActRandomizerV2._vamFilePath+_targetFileURLValue.val, true,"UNDRESS");}}
				else {
					JSONStorable js = null;
					if (_targetType.val == "LOADCLOTHPRESET"){js = nextActionAtom.GetStorableByID("ClothingPresets");}
					if (_targetType.val == "LOADAPPPRESET"){js = nextActionAtom.GetStorableByID("AppearancePresets");}
					if (_targetType.val == "LOADGENPRESET"){js = nextActionAtom.GetStorableByID("Preset");}
					if (_targetType.val == "LOADHAIRPRESET"){js = nextActionAtom.GetStorableByID("HairPresets");}
					if (_targetType.val == "LOADMORPHPRESET"){js = nextActionAtom.GetStorableByID("MorphPresets");}
					if (_targetType.val == "LOADPOSEPRESET"){js = nextActionAtom.GetStorableByID("PosePresets");}
					if (_targetType.val == "LOADBREASTPRESET"){js = nextActionAtom.GetStorableByID("FemaleBreastPhysicsPresets");if(nextActionAtom==null){js = nextActionAtom.GetStorableByID("MaleBreastPhysicsPresets");}}
					if (_targetType.val == "LOADGLUTEPRESET"){js = nextActionAtom.GetStorableByID("FemaleGlutePhysicsPresets");if(nextActionAtom==null){js = nextActionAtom.GetStorableByID("MaleGlutePhysicsPresets");}}
					if (_targetType.val == "LOADSKINPRESET"){js = nextActionAtom.GetStorableByID("SkinPresets");}			
					if (js!=null && _targetFileURLValue.val!=""){JSONStorableUrl presetPathJSON = js.GetUrlJSONParam("presetBrowsePath");
						presetPathJSON.val = SuperController.singleton.NormalizePath(_targetFileURLValue.val);
						js.CallAction("LoadPreset");
					}
				}			
			}
		}
        public JSONStorableStringChooser _atomName ; public JSONStorableString _atomType; public JSONStorableStringChooser _receiverGroupName ;public JSONStorableStringChooser _receiverName ;public JSONStorableStringChooser _targetName ;	public JSONStorableString _targetType; public JSONStorableStringChooser _targetStringChooserValue ; public JSONStorableStringChooser _targetAudioCategory ; public JSONStorableFloat _targetFloatValue ; public JSONStorableColor _targetColorValue ; public JSONStorableString _targetFileURLValue ; public JSONStorableString _targetStringValue ;public JSONStorableBool _targetBoolValue;
		public UIDynamicPopup _displayAtomPopup ; public UIDynamicPopup _displayReceiverGroupPopup ; public UIDynamicPopup _displayReceiverPopup ;  public UIDynamicPopup _displayTargetPopup ; public UIDynamicPopup _displayTargetValuePopup ; public UIDynamicPopup _displayAudioCategoryPopup ;protected UIDynamicSlider  _displayTargetValueFloatSlider; protected UIDynamicColorPicker _displayTargetValueColorPopup;protected UIDynamicToggle _displayTargetValueBoolToggle;protected UIDynamicButton _displayFileSelectButton; protected UIDynamicButton _displayClearFileSelectButton;protected UIDynamicTextField _displayTargetStringURL ;
        public RandomAct _parentAct;bool _isEndAction; public bool _disableUIUpdates = false;string _previousTargetType = "";
	}
	public class FileTypeFolder {public string fileType; public string defaultFolder;}
}